import { Modal } from 'modal';
import { Articulo, Bulto, TipoBulto } from 'expedicion-tipos';
declare type SeleccionBultoNuevo = {
    opcion: 'nuevo';
    numeroBultos: number;
    cantidadPorBulto: number;
    GVPALLETIP: TipoBulto;
};
declare type SeleccionBultoActualiza = {
    opcion: 'actualiza';
    bulto: Bulto;
};
declare type SeleccionBultoNinguno = {
    opcion: 'ninguno';
};
export declare type SeleccionBulto = SeleccionBultoNuevo | SeleccionBultoActualiza | SeleccionBultoNinguno;
export declare class DialogoSeleccionBulto {
    private _modal;
    private tabla;
    private botonSeleccionar;
    private botonNinguno;
    private botonNuevo;
    private botonDetalles;
    private cantidad;
    private bultos;
    private seleccionado;
    constructor(_modal: Modal, p_bultos: {
        N_BULTO: number;
        GVPALLETIP: TipoBulto;
        articulos: Articulo[];
    }[], p_cantidad: number);
    seleccionaBulto(p_bulto: any): void;
    actualizaVista(): void;
    seleccionar(): void;
    ninguno(): void;
    nuevo(): Promise<void>;
    detalles(): Promise<void>;
}
export {};
