Expedicion.prototype.FuncionesBultos = function () {
    exp.dialogOpening = false;
    if (exp.bulto.length > 0) {
        $('#bultoDetail').prop('disabled', false);
        $('#bultoSelec').prop('disabled', false);
    } else {
        $('#bultoDetail').prop('disabled', true);
        $('#bultoSelec').prop('disabled', true);
    }

    $('#dialogPedidos2 .close').on("click", function (e) {
        closeModal("#dialogPedidos2");
        e.preventDefault();
        e.stopPropagation();
        return false;

    });

    $('#bultoDetail').on("click", function () {
        var v_tabla = $('#tablaBultos').DataTable();
        var v_idBulto = eval(v_tabla.rows('.selected').data()[0].N_BULTO);
        var v_columnas = [generateColumn('GAART_COD', Resources.table_head_code), generateColumn('GAART_DESCRIP', Resources.table_head_description), generateColumn('C_UNI1', Resources.table_head_quantity, true, true)];
        var columnDefs = [
            { "width": "6em", "targets": 0 },
            { "width": "4em", "targets": 2 }
        ];
        //var url = Router.action('Dialog', 'Dialog');
        var url = "Dialog/Dialog";
        var buttons = [generateSingleButton('detBultoAceptar', Resources.button_accept)];
        generarDialogAuto(url, "#dialogBultoDetail", 'tablaDetallesBulto', null, exp.bulto[v_idBulto - 1]['v_articulos'], v_columnas, buttons, null, null, exp.DetallesBulto, Resources.title_packages, null, null, null, Resources.zeroRecordsMessage, null, null, columnDefs);
    });

    $('#bultoNuevo').on("click", function () {
        var url = "expedicion/tipospale";
        var method = "GET";
        var datos = { empgrupo_cod: sessionStorage.getItem("EMPRGRUP_COD"), emp_cod: sessionStorage.getItem("EMPR_COD") };
        var success = function (response) {
            var Ok = function () {
                //var url = Router.action('Dialog', 'Dialog');
                var url = "Dialog/Dialog";
                var v_data = response.Objeto;
                var v_columnas = [generateColumn('COD', Resources.table_head_code), generateColumn('DESCRIP', Resources.table_head_description)];
                var columnDefs = [
                    { "width": "6em", "targets": 0 }
                ];
                var buttons = [generateSingleButton('tipoBultoSelec', Resources.button_select)];
                generarDialogAuto(url, "#dialogBultoNuevo", 'tablaTiposBulto', null, v_data, v_columnas, buttons, null, null, exp.BultoNuevo, Resources.title_packages_new, null, null, null, Resources.zeroRecordsMessage, null, null, columnDefs);
            };
            handleResponse(response, Ok);
        };
        apiGeneral(url, method, datos, success);
    });

    $('#bultoNing').on("click", function () {
        exp.RecogerDetalles();
        closeModal("#dialogPedidos2");
        closeModal("#dialogLoV");
    });

    $('#bultoSelec').on("click", function () {
        var v_tabla = $('#tablaBultos').DataTable();
        exp.SeleccionBulto(v_tabla.rows('.selected').data()[0].N_BULTO);

        exp.RecogerDetalles();
        closeModal("#dialogPedidos2");
        closeModal("#dialogLoV");
    });
};

Expedicion.prototype.FuncionesBultosDetail = function () {
    if (exp.bulto.length > 0) {
        $('#bultoDetailMenu').prop('disabled', false);
    } else {
        $('#bultoDetailMenu').prop('disabled', true);
    }
    $('#bultoDetailMenu').on("click", function () {
        var v_tabla = $('#tablaBultosDetail').DataTable();
        var v_idBulto = eval(v_tabla.rows('.selected').data()[0].N_BULTO);
        var v_columnas = [generateColumn('GAART_COD', Resources.table_head_code), generateColumn('GAART_DESCRIP', Resources.table_head_description), generateColumn('C_UNI1', Resources.table_head_quantity, true, true)];
        var columnDefs = [
            { "width": "6em", "targets": 0 },
            { "width": "4em", "targets": 2 }
        ];
        //var url = Router.action('Dialog', 'Dialog');
        var url = "Dialog/Dialog";

        var buttons = [generateSingleButton('detBultoAceptarMenu', Resources.close)];

        generarDialogAuto(url, "#dialogBultoDetailMenu", 'tablaDetallesBulto1', null, exp.bulto[v_idBulto - 1]['v_articulos'], v_columnas, buttons, null, null, exp.DetallesBultoMenu, Resources.packages, null, null, null, null, null, null, columnDefs);
    });

    $('#closeDetailMenu').on('click', function () {
        closeModal("#dialogLoV");
    });
};

Expedicion.prototype.DetallesBultoMenu = function () {
    $("#dialogBultoDetailMenu .close").on("click", function (event) {
        closeModal("#dialogBultoDetailMenu");
        event.preventDefault();
        event.stopPropagation();
        return false;
    });

    $("#detBultoAceptarMenu").on("click", function () {
        closeModal("#dialogBultoDetailMenu");
    });
};


Expedicion.prototype.DetallesBulto = function () {
    $("#dialogBultoDetail .close").on("click", function (event) {
        closeModal("#dialogBultoDetail");
        $("#campRefer").focus().select();
        event.preventDefault();
        event.stopPropagation();
        return false;
    });

    $("#detBultoAceptar").on("click", function () {
        closeModal("#dialogBultoDetail");
    });
};

Expedicion.prototype.BultoNuevo = function () {
    $("#dialogBultoNuevo .close").on("click", function (event) {
        closeModal("#dialogBultoNuevo");
        event.preventDefault();
        event.stopPropagation();
        return false;
    });

    $("#tipoBultoSelec").on("click", function () {
        exp.NuevoBulto();
        exp.RecogerDetalles();
        closeModal("#dialogBultoNuevo");
        closeModal("#dialogPedidos2");
        closeModal("#dialogLoV");
    });
};

Expedicion.prototype.RecogerDatos = function () {
    exp.v_orden_exp = {
        EMPGRUPO_COD: sessionStorage.getItem("EMPRGRUP_COD"),
        EMP_COD: sessionStorage.getItem("EMPR_COD"),
        GGPEDTIP_COD: exp.data.GGPEDTIP_COD,
        N_PEDIDO: exp.data.N_PEDIDO,
        GGMENVIO_COD: $('#codTransporte').val(),
        GGVEHICULO_COD: $("#codVehiculo").val(),
        GGALBTIP_COD: $("#tipoAlbaran").val(),
        N_ALBARAN: $("#numAlbaran").val(),
        F_ALBARAN: getFechaAlbaran(),
        N_BULTOS: exp.bulto.length,
        Bultos: exp.bulto,
        LINEAS: exp.v_lineas_pedido
    };
};


Expedicion.prototype.RecogerDetalles = function () {
    for (i = 0; i < exp.v_lineas_pedido.length; i++) {
        if (!exp.v_lineas_pedido[i]["Detalles"]) {
            exp.v_lineas_pedido[i]["Detalles"] = new Array();
        }
        for (j = 0; j < exp.detallesProd.length; j++) {
            if (exp.v_lineas_pedido[i].N_LIN === eval(exp.detallesProd[j].id)) {
                if (!exp.Repetido(i) && (exp.detallesProd[j].GAUBIC_COD || exp.detallesProd[j].LOTE)) {
                    exp.v_lineas_pedido[i]["Detalles"].push(exp.detallesProd[j]);
                }
                if (!exp.v_lineas[i].C_PDTE) {
                    exp.v_lineas[i].C_PDTE = eval(exp.detallesProd[j].C_UNI1);
                } else {
                    exp.v_lineas_pedido[i]['C_UNI1'] = exp.v_lineas_pedido[i]['C_UNI1'] + eval(exp.detallesProd[j].C_UNI1);
                }
                encontrado = true;
            }
        }
    }
    var pos_v_lineas;
    var encontrado = false;

    exp.data = JSON.parse(JSON.stringify(exp.v_dataClon));

    for (i = 0; i < exp.v_lineas.length && !encontrado; i++) {
        if (exp.data.Lineas[i].N_LIN === $('#tablaPedidos').DataTable().rows('#' + exp.v_posicion_pedido).data()[0].N_LIN) {
            pos_v_lineas = i;
            encontrado = true;
        }
    }


    var v_table = $('#tablaPedidos').DataTable();
    v_table.row('#' + exp.v_posicion_pedido).data(exp.data.Lineas[pos_v_lineas]).draw();
    exp.CambioColorPedido(exp.v_lineas_pedido);
    exp.ActualizarBultos();
    $("#campRefer").focus().select();
};

Expedicion.prototype.CambioColorPedido = function (v_lineas_pedido) {
    var v_table = $('#tablaPedidos').DataTable();
    var row = v_table.row('#' + exp.v_posicion_pedido).node();

    for (i = 0; i < v_lineas_pedido.length; i++) {
        if (v_lineas_pedido[i].N_LIN === exp.v_posicion_pedido && v_lineas_pedido[i].C_UNI1 !== 0) {
            if (!$(row).hasClass('green')) {
                $(row).addClass('green');
            }
            return;
        }
    }
};


Expedicion.prototype.Repetido = function (i) {
    for (k = 0; k < exp.v_lineas_pedido[i]["Detalles"].length; k++) {
        if (exp.detallesProd[j]['LOTE'] === exp.v_lineas_pedido[i]["Detalles"][k]['LOTE'] && exp.detallesProd[j]['GAUBIC_COD'] === exp.v_lineas_pedido[i]["Detalles"][k]['GAUBIC_COD']) {
            exp.v_lineas_pedido[i]["Detalles"][k]['C_UNI1'] = eval(exp.v_lineas_pedido[i]["Detalles"][k]['C_UNI1']) + eval(exp.detallesProd[j]['C_UNI1']);
            return true;
        }
    }
    return false;
};

Expedicion.prototype.SeleccionBulto = function( numBulto) {
    exp.GenerarBulto( numBulto);
};

Expedicion.prototype.NuevoBulto = function() {
    exp.GenerarBulto(null);
};

Expedicion.prototype.GenerarBulto = function (numBulto) {
    var v_articulos = new Array();
    var v_NUM_Pedido = exp.v_dataClon.N_PEDIDO;       
    var v_cantidad = exp.v_pedidoActual_cant;
    var v_tablaPed = $('#tablaPedidos').DataTable();
    exp.v_descr_articulo = v_tablaPed.rows('#' + exp.v_posicion_pedido).data()[0].GAART_COD;
    exp.v_nombre_articulo = v_tablaPed.rows('#' + exp.v_posicion_pedido).data()[0].GAART_DESCRIP;
    if ( !numBulto ) {        
        exp.v_numBulto = exp.v_numBulto + 1;        
        v_tablaTiposBulto = $('#tablaTiposBulto').DataTable();
        v_tipoBulto = v_tablaTiposBulto.rows('.selected').data()[0].COD;
        v_articulos.push({ N_BULTO: exp.v_numBulto, GGPEDLIN_N_LIN: exp.v_posicion_pedido, GAART_COD: exp.v_descr_articulo, C_UNI1: exp.v_pedidoActual_cant, GAART_DESCRIP: exp.v_nombre_articulo });
        exp.bulto.push({ N_BULTO: exp.v_numBulto, v_NUM_Pedido: v_NUM_Pedido, v_numBulto: exp.v_numBulto, v_tipoBulto: v_tipoBulto, v_articulos: v_articulos, v_cantidad: v_cantidad });
    } else {
        exp.v_numBulto = numBulto;
        v_articulos.push({ N_BULTO: exp.v_numBulto, GGPEDLIN_N_LIN: exp.v_posicion_pedido, GAART_COD: exp.v_descr_articulo, C_UNI1: exp.v_pedidoActual_cant, GAART_DESCRIP: exp.v_nombre_articulo });
        exp.AddBulto( numBulto, v_articulos[0]);        
    }    
};

Expedicion.prototype.AddBulto = function (numBulto, articulos) {
    var encontrado = false;
    numBulto = numBulto - 1;
    var v_articulosBulto = exp.bulto[eval( numBulto)]["v_articulos"];
    for (var i = 0; i < v_articulosBulto.length && !encontrado; i++) {        
        if (v_articulosBulto[i]["GGPEDLIN_N_LIN"] === articulos['GGPEDLIN_N_LIN']) {
            v_articulosBulto[i]["C_UNI1"] = v_articulosBulto[i]["C_UNI1"] + articulos['C_UNI1'];
            encontrado = true;
        }        
    }
    if (!encontrado) {
        exp.bulto[numBulto]["v_articulos"].push( articulos);        
    }
    exp.bulto[numBulto]['v_cantidad'] = exp.bulto[numBulto]['v_cantidad'] + exp.v_pedidoActual_cant;
    exp.RecogerDatos();
};
Expedicion.prototype.FocusTransport = function () {
    $(exp.inpCodTransportista).focus().select();
};

Expedicion.prototype.FocusVehicle = function() {
    $(exp.inpCodVehiculo).focus().select();
};

Expedicion.prototype.FocusBultos = function() {
    $(exp.inpCodTransportista).focus().select();
    $("#bultosInput").focus().select();
};
Expedicion.prototype.FocusPeso = function() {
    $("#pesoInput").focus().select();
};
Expedicion.prototype.FocusEtiquetas = function() {
    $("#etiquetasInput").focus().select();
};
    
Expedicion.prototype.CambioTransportista = function () {
    if ($(exp.inpCodTransportista).val() !== '') {
        var url = "expedicion/ModoEnvio";
        var datos = { empgrupo_cod: sessionStorage.getItem("EMPRGRUP_COD"), emp_cod: sessionStorage.getItem("EMPR_COD"), GGMENVIO_COD: $(exp.inpCodTransportista).val() };
        var method = "GET";
        var success = function (response, status, xhr) {
            var Ok = function () {
                $('#codTransportistaInput').val(response.Objeto.COD);
                $('#nombreTransportistaInput').val(response.Objeto.DESCRIP);
                exp.LimpiarVehiculos();
            };
            var error = function () {
                $('#nombreTransportistaInput').val("");
                exp.LimpiarVehiculos();
                exp.FocusTransport();
            };
            handleResponse(response, Ok, error);
        };

        apiGeneral(url, method, datos, success);
    } else {
        $('#nombreTransportistaInput').val("");
        exp.LimpiarVehiculos();
    }
};

Expedicion.prototype.CambioVehiculo = function () {
    if ($(exp.inpCodVehiculo).val() !== '') {
        var url = "expedicion/Vehiculo";
        var v_datos = { empgrupo_cod: sessionStorage.getItem("EMPRGRUP_COD"), emp_cod: sessionStorage.getItem("EMPR_COD"), ggmenvio_cod: $('#codTransportistaInput').val(), cod: $(exp.inpCodVehiculo).val() };
        var method = "GET";
        var success = function (response) {
            var Ok = function () {
                $('#codVehiculoInput').val(response.Objeto.COD);
                $('#descrVehiculoInput').val(response.Objeto.DESCRIP);
            };
            var error = function () {
                $('#descrVehiculoInput').val('');
                exp.FocusVehicle();
            };
            handleResponse(response, Ok, error);
        };
        apiGeneral(url, method, v_datos, success);
    } else {
        exp.LimpiarVehiculos();
    }
};

Expedicion.prototype.SearchTransporter = function () {
    var url = "expedicion/ModosEnvio";
    var method = "GET";
    var datos = { empgrupo_cod: sessionStorage.getItem("EMPRGRUP_COD"), emp_cod: sessionStorage.getItem("EMPR_COD") };
    var success = function (response) {
        var Ok = function () {
            //var url = Router.action('Dialog', 'Dialog');
            var url = "Dialog/Dialog";
            var v_columns = [generateColumn('COD', Resources.table_head_code), generateColumn('DESCRIP', Resources.table_head_description)];
            var columnDefs = [
                { "width": "6em", "targets": 0 }
            ];
            var v_buttons = [generateSingleButton("datosEnvioAccept", Resources.button_accept)];
            generarDialogAuto(url, "#dialogLoV", "tableTransporter", null, response.Objeto, v_columns, v_buttons, null, null, TransporterFunctions, Resources.title_shipping_data, null, null, null, null, null, null, columnDefs, true);
        };
        handleResponse(response, Ok);
    };
    apiGeneral(url, method, datos, success);
};

Expedicion.prototype.SearchVehicle = function () {
    var url = "expedicion/Vehiculos";
    var datos = { empgrupo_cod: sessionStorage.getItem("EMPRGRUP_COD"), emp_cod: sessionStorage.getItem("EMPR_COD"), ggmenvio_cod: $('#codTransportistaInput').prop('value') };
    var method = "GET";
    var success = function (response) {
        var Ok = function () {
            //var url = Router.action('Dialog', 'Dialog');
            var url = "Dialog/Dialog";
            var v_columns = [generateColumn('COD', Resources.table_head_code), generateColumn('DESCRIP', Resources.table_head_description)];
            var v_buttons = [generateSingleButton("datoEnvioAccept", Resources.button_accept)];
            generarDialogAuto(url, "#dialogLoV", "tableVehicle", null, response.Objeto, v_columns, v_buttons, null, null, VehicleFunctions, Resources.title_shipping_vehicle_data, null, null, null, null, null, null, null, true);
        };
        handleResponse(response, Ok);
    };
    apiGeneral(url, method, datos, success);
};

Expedicion.prototype.EnvioAceptar = function () {
    var url = "expedicion/Vehiculo";
    var v_datos = {
        empgrupo_cod: sessionStorage.getItem("EMPRGRUP_COD"),
        emp_cod: sessionStorage.getItem("EMPR_COD"),
        ggmenvio_cod: $('#codTransportistaInput').val(),
        cod: $('#codVehiculoInput').val()
    };
    var method = "GET";
    var success = function (response) {
        var Ok = function () {
            exp.DatosEnvio();
            $('#dialogEnviosEtiquetas').modal('hide');
            lanzarAlbaranes();
        };
        var error = function () {
            $('#descrVehiculoInput').val('');
        };
        handleResponse(response, Ok, error);
    };
    apiGeneral(url, method, v_datos, success);
};

function TransporterFunctions() {
    $('.close').on("click", function () {
        closeModal("#dialogDatosEnvio");
    });
    $('#datosEnvioAccept').on("click", function () {
        var v_table = $("#tableTransporter").DataTable();
        if (v_table.rows().data().length > 0) {
            var v_codTransportista = v_table.rows('.selected').data()[0].COD;
            var v_nombreTransportista = v_table.rows('.selected').data()[0].DESCRIP;
            $('#codTransportistaInput').val(v_codTransportista);
            $('#nombreTransportistaInput').val(v_nombreTransportista);
            exp.LimpiarVehiculos();
        }
        closeModal('#dialogLoV');
    });
};

function VehicleFunctions() {
    $('.close').on("click", function () {
        closeModal("#dialogDatosEnvio");
    });
    $('#datoEnvioAccept').on("click", function () {
        var v_table = $("#tableVehicle").DataTable();
        var v_data_table = v_table.rows('.selected').data();
        if (v_data_table.length !== 0) {
            var v_codVehiculo = v_data_table[0].COD;
            var v_descrVehiculo = v_data_table[0].DESCRIP;
            if (v_table.rows().data().length > 0) {
                $('#codVehiculoInput').val(v_codVehiculo);
                $('#descrVehiculoInput').val(v_descrVehiculo);
            }
        }
        closeModal('#dialogLoV');
    });
};

Expedicion.prototype.LimpiarVehiculos = function() {
    $('#codVehiculoInput').val("");
    $('#descrVehiculoInput').val("");
};

Expedicion.prototype.DatosEnvio = function() {
    $('#codTransporte').val($('#codTransportistaInput').val());
    $('#nombreTransporte').val($('#nombreTransportistaInput').val());
    $('#codVehiculo').val($('#codVehiculoInput').val());
    $('#descrVehiculo').val($('#descrVehiculoInput').val());
};

Expedicion.prototype.Expedir = function () {
    exp.SeleccionTransporte();
};

Expedicion.prototype.GestionarImpresionPendiente = function () {
    var AlbFn = function () {
        exp.ExpedirFn();
        closeModal("#dialogLoV");
    };
    var EtiqFn = function () {
        exp.ImprimirFn();
        closeModal("#dialogLoV");
    };

    var btnFunctions = function () {
        $("#btnPHAlb").on("click", AlbFn);
        $("#btnPHEtiq").on("click", EtiqFn);
    };
    //var url = Router.action('Dialog', 'Dialog');
    var url = "Dialog/Dialog";
    var buttons = [
        generateSingleButton("btnPHAlb", "Albarán", "pull-right", "default"),
        generateSingleButton("btnPHEtiq", "Alb. + Etiq.", "pull-left", "gray")
    ];
    var Mensaje = "Se está dejando el albarán en estado PENDIENTE. \n \
    ¿Desea imprimir etiquetas o solo el albarán?";
    generarDialogAuto(url, "#dialogLoV", null, null, null, null, buttons, null, null, btnFunctions, "Mensaje", null, Mensaje);
};


Expedicion.prototype.ImprimirExpedicion = function () {
        exp.DatosEnvio();
    //Recoger datos restantes de expedición
    exp.v_orden_exp['GGMENVIO_COD'] = $('#codTransporte').val();
    exp.v_orden_exp['GGVEHICULO_COD'] = $("#codVehiculo").val();
    exp.TransformExpedicion();
    exp.v_orden_exp.N_BULTOS = $('#bultosInput').val();
    exp.v_orden_exp.N_ETIQUETAS = $('#etiquetasInput').val();
    exp.v_orden_exp.PESO = $('#pesoInput').val();
    exp.v_orden_exp.OPCION_ETIQUETAS = $(exp.selectType).val();
    exp.v_orden_exp.ImprimirValorado = $(exp.chkAlbaranVal).is(':checked');
        exp.v_orden_exp.N_COPIAS = exp.DejarPendiente ? $('#CopiasInput').val(): null;
    

    //Params Expedir
    if (exp.DejarPendiente)
        exp.GestionarImpresionPendiente();
    else
        exp.ImprimirFn();
};

Expedicion.prototype.ExpedirFn = function () {
    //Params
    var url = "expedicion/Expedir";
    var data = exp.v_orden_exp;
    var method = "POST";
    var success = function (response) {
        if (response.Ok) {
            var GGALBTIP_COD = response.Objeto.GGALBTIP_COD;
            var N_ALBARAN = response.Objeto.N_ALBARAN;
            if (response.Objeto.PREGUNTA_HIST) {
                var acceptFn = function () {

                    var url = "/Expedicion/PonerHistorico";
                    var method = "POST";
                    var data = {
                        empgrupo_cod: sessionStorage.getItem("EMPRGRUP_COD"),
                        emp_cod: sessionStorage.getItem("EMPR_COD"),
                        GGPEDTIP_COD: exp.v_orden_exp.GGPEDTIP_COD,
                        N_PEDIDO: exp.v_orden_exp.N_PEDIDO
                    };
                    var success = function (response) {
                        var ok = function () {
                            closeModal('#dialogEnviosEtiquetas');
                            closeModal("#dialogLoV");
                            exp.Clear();
                        };
                        var error = function () {

                        };
                        if (response.Ok) {
                            lanzarMensaje(true, "Se ha generado el albarán " + GGALBTIP_COD + " - " + N_ALBARAN, ok);
                        } else {
                            lanzarMensaje(false, response.Mensaje, error);
                        }
                        //handleResponse(response, ok, error);
                    };
                    apiGeneral(url, method, data, success);
                };
                var cancelFn = function () {
                    var url = "/Expedicion/DejarActivo";
                    var method = "POST";
                    var data = {
                        empgrupo_cod: sessionStorage.getItem("EMPRGRUP_COD"),
                        emp_cod: sessionStorage.getItem("EMPR_COD"),
                        GGPEDTIP_COD: exp.v_orden_exp.GGPEDTIP_COD,
                        N_PEDIDO: exp.v_orden_exp.N_PEDIDO
                    };
                    var success = function (response) {
                        var ok = function () {
                            closeModal('#dialogEnviosEtiquetas');
                            closeModal("#dialogLoV");
                            exp.Clear();
                        };
                        var error = function () {

                        };
                        if (response.Ok) {
                            lanzarMensaje(true, "Se ha generado el albarán " + GGALBTIP_COD + " - " + N_ALBARAN, ok);
                        } else {
                            lanzarMensaje(false, response.Mensaje, error);
                        }
                        //handleResponse(response, ok, error);
                    };
                    apiGeneral(url, method, data, success);
                };
                //lanzarConfirmacion(response.Objeto.PREGUNTA_HIST, acceptFn, cancelFn);
                var btnFunctions = function () {
                    $("#btnPHSi").on("click", acceptFn);
                    $("#btnPHNo").on("click", cancelFn);
                };
                //var url = Router.action('Dialog', 'Dialog');
                var url = "Dialog/Dialog";
                var buttons = [
                    generateSingleButton("btnPHSi", "Aceptar", "pull-right"),
                    generateSingleButton("btnPHNo", "Cancelar", "pull-left", "gray")
                ];
                generarDialogAuto(url, "#dialogLoV", null, null, null, null, buttons, null, null, btnFunctions, "Mensaje", null, response.Objeto.PREGUNTA_HIST);
            } else {
                var Ok = function () {
                    closeModal('#dialogEnviosEtiquetas');
                    exp.Clear();
                };
                var error = function () {

                };
                if (response.Ok) {
                    lanzarMensaje(true, "Se ha generado el albarán " + GGALBTIP_COD + " - " + N_ALBARAN, Ok);
                } else {
                    lanzarMensaje(false, response.Mensaje, error);
                }
                //handleResponse(response, Ok, error);
            }
        } else {
            lanzarMensaje(response.Ok, response.Mensaje);
        }

    };

    //API call
    apiGeneral(url, method, data, success);
}
Expedicion.prototype.ImprimirFn = function () {
    var url = "expedicion/Expedir";
    var data = exp.v_orden_exp;
    var method = "POST";
    var success = function (response) {
        var Ok = function () {
            //Params Impresión etiquetas
            var url = "impresion/imprimiretiqueta";
            var data = {
                empgrupo_cod: sessionStorage.getItem("EMPRGRUP_COD"),
                emp_cod: sessionStorage.getItem("EMPR_COD"),
                ggalbtip_cod: response.Objeto.GGALBTIP_COD,
                n_albaran: response.Objeto.N_ALBARAN
            };
            var method = 'PUT';
            var success = function (response) {
                if (response.Ok) {
                    var GGALBTIP_COD = response.Objeto.GGALBTIP_COD;
                    var N_ALBARAN = response.Objeto.N_ALBARAN;
                    if (response.Objeto.PREGUNTA_HIST) {
                        var acceptFn = function () {
                            var url = "/Expedicion/PonerHistorico";
                            var method = "POST";
                            var data = {
                                empgrupo_cod: sessionStorage.getItem("EMPRGRUP_COD"),
                                emp_cod: sessionStorage.getItem("EMPR_COD"),
                                GGPEDTIP_COD: exp.v_orden_exp.GGPEDTIP_COD,
                                N_PEDIDO: exp.v_orden_exp.N_PEDIDO
                            };
                            var success = function (response) {
                                var ok = function () {
                                    closeModal('#dialogEnviosEtiquetas');
                                    closeModal("#dialogLoV");
                                    exp.Clear();
                                };
                                var error = function () {

                                };
                                if (response.Ok) {
                                    lanzarMensaje(true, "Se ha generado el albarán " + GGALBTIP_COD + " - " + N_ALBARAN, ok);
                                } else {
                                    lanzarMensaje(false, response.Mensaje, error);
                                }
                                //handleResponse(response, ok, error);
                            };
                            apiGeneral(url, method, data, success);
                        };
                        var cancelFn = function () {
                            var url = "/Expedicion/DejarActivo";
                            var method = "POST";
                            var data = {
                                empgrupo_cod: sessionStorage.getItem("EMPRGRUP_COD"),
                                emp_cod: sessionStorage.getItem("EMPR_COD"),
                                GGPEDTIP_COD: exp.v_orden_exp.GGPEDTIP_COD,
                                N_PEDIDO: exp.v_orden_exp.N_PEDIDO
                            };
                            var success = function (response) {
                                var ok = function () {
                                    closeModal("#dialogLoV");
                                    closeModal('#dialogEnviosEtiquetas');
                                    exp.Clear();
                                };
                                var error = function () {

                                };

                                if (response.Ok) {
                                    lanzarMensaje(true, "Se ha generado el albarán " + GGALBTIP_COD + " - " + N_ALBARAN, ok);
                                } else {
                                    lanzarMensaje(false, response.Mensaje, error);
                                }
                                //handleResponse(response, ok, error);
                            };
                            apiGeneral(url, method, data, success);
                        };
                        var btnFunctions = function () {
                            $("#btnPHSi").on("click", acceptFn);
                            $("#btnPHNo").on("click", cancelFn);
                        };
                        //var url = Router.action('Dialog', 'Dialog');
                        var url = "Dialog/Dialog";
                        var buttons = [
                            generateSingleButton("btnPHSi", "Aceptar", "pull-right"),
                            generateSingleButton("btnPHNo", "Cancelar", "pull-left", "gray")
                        ];
                        generarDialogAuto(url, "#dialogLoV", null, null, null, null, buttons, null, null, btnFunctions, "Mensaje", null, response.Objeto.PREGUNTA_HIST);
                    } else {
                        var Ok = function () {
                            closeModal('#dialogEnviosEtiquetas');
                            exp.Clear();
                        };
                        var error = function () {

                        };
                        if (response.Ok) {
                            lanzarMensaje(true, "Se ha generado el albarán " + GGALBTIP_COD + " - " + N_ALBARAN, Ok);
                        } else {
                            lanzarMensaje(false, response.Mensaje, error);
                        }
                        //handleResponse(response, Ok, error);
                    }
                } else {
                    lanzarMensaje(response.Ok, response.Mensaje);
                }
            };
            //API CALL Impresión de etiquetas
            apiGeneral(url, method, data, success);
        };
        handleResponse(response, Ok);
    };

    apiGeneral(url, method, data, success);
}
Expedicion.prototype.GenerarExpedicion = function () {
    exp.DatosEnvio();
    exp.v_orden_exp['GGMENVIO_COD'] = $('#codTransporte').val();
    exp.v_orden_exp['GGVEHICULO_COD'] = $("#codVehiculo").val();
    exp.TransformExpedicion();
    exp.v_orden_exp.N_BULTOS = $('#bultosInput').val();
    exp.v_orden_exp.N_ETIQUETAS = $('#etiquetasInput').val();
    exp.v_orden_exp.PESO = $('#pesoInput').val();
    exp.v_orden_exp.ImprimirValorado = $(exp.chkAlbaranVal).is(':checked');
    exp.v_orden_exp.DejarPendiente = exp.DejarPendiente;
    exp.v_orden_exp.N_COPIAS = exp.DejarPendiente ? $('#CopiasInput').val(): null;

    exp.ExpedirFn();
    
};

Expedicion.prototype.TransformExpedicion = function () {
    if (eval(exp.v_orden_exp.N_BULTOS) > 0 && exp.v_orden_exp.Bultos.length > 0 && exp.v_orden_exp.Bultos[0].v_articulos) {
        exp.v_bultos = [];
        for (var i = 0; i < exp.v_orden_exp.Bultos.length; i++) {
            for (j = 0; j < exp.v_orden_exp.Bultos[i].v_articulos.length; j++) {
                exp.v_orden_exp.Bultos[i].v_articulos[j].GVPALLETIP_COD = exp.v_orden_exp.Bultos[i].v_tipoBulto;
                exp.v_bultos.push(exp.v_orden_exp.Bultos[i].v_articulos[j]);
            }
        }
        exp.v_orden_exp.Bultos = exp.v_bultos;
    }
};

var v_albaran = "";

Expedicion.prototype.MenuInit = function () {
    //Inicializa el menu cada vez que se introduce un nuevo pedido dejando el botón de desconexión
    $('#nav-user').find('li:not(:first)').remove();
};

Expedicion.prototype.GenerarMenu = function() {
    exp.cambioAlbaran();

    menuInit();
    menuElement(Resources.menu_delivery_note_date, 'fecha', '#', dateToString(getDateAlb(exp.v_albaranSeleccionado)), 'buscador', 'menuDate', 'data-provide="datepicker"');
    menuElement(Resources.menu_delivery_note_change, 'observaciones', '#', v_albaran, 'buscador', 'menuAlbaran');
    menuElement(Resources.menu_packages, 'observaciones', '#', "Nº Bultos: " + exp.v_bultos.length, '', 'menuBultos');
    menuElement(Resources.menu_observations, 'observaciones', '#', "Mostrar", '', 'menuObservaciones');
    //Carga las fechas y genera el datePicker
    menuDatePicker();

    $("#tipoAlbaran").bind("change paste keyup", function () {
        exp.CambioAlbaran();
    });
    $("#numAlbaran").bind("change paste keyup", function () {
        exp.CambioAlbaran();
    });

    $('#menuAlbaran').on('click', function () {
        if (exp.data) {
            //var url = Router.action('Dialog', 'Dialog');
            var url = "Dialog/Dialog";

            var v_columns = [generateColumn('GGALBTIP_COD', Resources.table_head_type),
                generateColumn('N_ALBARAN', Resources.table_head_number, true, true),
                generateColumn('F_ALBARAN', Resources.table_head_date),
                generateColumn('GGESTADO_COD', Resources.table_head_state),
                generateColumn('F_ALBARAN_HID', '', false)
            ];
            var columnDefs = [
                { "width": "4em", "targets": 0 },
                { "width": "4em", "targets": 1 },
                { "width": "2em", "targets": 3 }
            ];
            var buttons = [generateSingleButton('seleccionarAlbaran', Resources.button_select, 'pull-right'), generateSingleButton('nuevoAlbaran', Resources.button_new, 'pull-left')];
            var v_albaranes = exp.data.Albaranes.map(function (albaran) {
                return {
                    GGALBTIP_COD: albaran.GGALBTIP_COD,
                    N_ALBARAN: albaran.N_ALBARAN,
                    //Fecha formateada para su visualización
                    F_ALBARAN: moment( albaran.F_ALBARAN).format(Globalize($("html").attr("lang")).culture().calendar.patterns.d.toUpperCase()),
                    GGESTADO_COD: albaran.GGESTADO_COD,
                    SU_REF_ALB: albaran.SU_REF_ALB,
                    //Fecha sin formatear (Oculto)
                    F_ALBARAN_HID: albaran.F_ALBARAN
                };
            });
            generarDialogAuto(url, "#dialogLoV", 'tablaAlbaranes', null, v_albaranes, v_columns, buttons, null, null, exp.SelectAlbaran, Resources.title_delivery_note_selection, null, null, null, null, null, null, columnDefs);
        } else {
            lanzarMensaje(false, Resources.error_insert_order);
        }
    });


    $('#menuBultos').on('click', function () {
        if (exp.data) {
            exp.LanzarVentanaBultosDetail();
        } else {
            lanzarMensaje(false, Resources.error_insert_order);
        }
    });

    $('#menuObservaciones').on('click', function () {
        if (exp.data) {
            if (exp.data.OBSER && exp.data.OBSER.trim() !== "")
                lanzarMensaje(true, exp.data.OBSER);
            else
                lanzarMensaje(true, Resources.message_no_observations);
        } else {
            lanzarMensaje(false, Resources.error_insert_order);
        }
    });
}

Expedicion.prototype.ActualizarBultos = function() {
    $('#menuBultos div input').val(Resources.menu_package_quantity + ": " + exp.bulto.length);
}
    
window.addEventListener('load', function () {
    var v_columns = [
        generateColumn("N_LIN", "", false),
        generateColumn("GAART_UBIC_SN", "", false),
        generateColumn("GAART_LOTES_SN", "", false),
        generateColumn("GAART_COD", Resources.table_head_article),
        generateColumn("GAART_DESCRIP", Resources.table_head_description),
        generateColumn("C_PDTE", Resources.table_head_pending, true, true)];
    var columnDefs = [
        { width: '6em', targets: 3 },
        { width: '4em', targets: 5 }
    ];
    createTableJson('#tablaPedidos', null, v_columns, null, null, columnDefs, false);

    exp = new Expedicion();
    exp.initialize();

    addEvent(exp.btnNuevo, 'click', exp.Clear, false);
    addEvent(exp.btnContinuarExped, 'click', exp.GenerarExpedicion, false);
    addEvent(exp.btnImprimirExped, 'click', exp.ImprimirExpedicion, false);
    addEvent(exp.btnCampRefer, 'click', exp.ClearCode, false);
    addEvent(exp.btnEnvioAceptar, 'click', exp.EnvioAceptar, false);
    addEvent(exp.btnConfirm, 'click', exp.Confirmar, false);
    addEvent(exp.btnPdte, 'click', exp.Pendiente, false);
    addEvent(exp.refCant.get(0), 'change', exp.CantSinLotUb, false);
    // RBM 03/03/20 Cambio la validación con la pulsación del Intro para hacerla con el evento 'change'
    //exp.txtPedido.keydown(exp.ObtenerPedido);
    exp.txtPedido.on("change", exp.ObtenerPedido);
    // RBM 03/03/20 Cambio la validación con la pulsación del Intro para hacerla con el evento 'change'
    //exp.campRefer.keyup(exp.SearchByRef);
    exp.campRefer.on("change", exp.SearchByRef);
    exp.tBody.on('click', 'tr', exp.SelectArticle);

    addEvent(exp.inpCodTransportista, 'change', exp.CambioTransportista, false);
    addEvent(exp.inpCodVehiculo, 'change', exp.CambioVehiculo, false);
    addEvent(exp.btnTransporterSearch, 'click', exp.SearchTransporter, false);
    addEvent(exp.btnVehicleSearch, 'click', exp.SearchVehicle, false);

    // RBM 03/03/20 Cambio la validación con la pulsación del Intro para hacerla con el evento 'change'
    //$(exp.bultosInput).keypress(function (e) { if (e.which === 13) exp.FocusPeso(); });
    //$(exp.pesoInput).keypress(function (e) { if (e.which === 13) exp.FocusEtiquetas(); });
    //$(exp.etiquetasInput).keypress(function (e) { if (e.which === 13) exp.FocusTransport(); });
    //$(exp.inpCodTransportista).keypress(function (e) { if (e.which === 13) exp.FocusVehicle(); });
    //$(exp.inpCodVehiculo).keypress(function (e) { if (e.which === 13) exp.FocusBultos(); });
    //$(exp.bultosInput).on("change", function (e) { exp.FocusPeso(); });
    //$(exp.pesoInput).on("change", function (e) { exp.FocusEtiquetas(); });
    //$(exp.etiquetasInput).on("change", function (e) { exp.FocusTransport(); });
    //$(exp.inpCodTransportista).on("change", function (e) { exp.FocusVehicle(); });
    //$(exp.inpCodVehiculo).on("change", function (e) { exp.FocusBultos(); });

    exp.txtPedido.focus().select();
});

$(window).resize(function () {
    resizePedidos();
});

function resizePedidos() {
    if ($(window).width() < 400) {
        $('#ref .sinLote label').removeClass('col-xs-12').addClass('col-xs-2');

    } else {
        $('#ref .sinLote label').removeClass('col-xs-2').addClass('col-xs-12');
    }
}

function Expedicion() {
    this.v_tabla;
    this.data;
    this.v_dataClon;
    this.detallesProd = [];
    this.v_lineas;
    this.v_lineas_pedido = [];
    this.v_orden_exp = new Array();
    this.v_cant_linea;
    this.dataAux;
    this.v_pedidoActual_cant;
    this.bulto = [];
    this.v_bultos = [];
    this.v_control_lote_ubic;
    this.v_posicion_pedido;
    this.v_numBulto = 0;
    this.v_albaranSeleccionado = null;
    this.dialogOpening = false;
    this.DejarPendiente = false;

    this.btnNuevo = document.getElementById('btnNuevoPedido');
    this.btnContinuarExped = document.getElementById('ContinuarExped');
    this.btnImprimirExped = document.getElementById('ImprimirExped');
    this.btnCampRefer = document.getElementById('campRefer');
    this.btnEnvioAceptar = document.getElementById('envioAceptar');
    this.btnConfirm = document.getElementById('confirmar');
    this.btnPdte = document.getElementById('btnPdte');
    this.tBody = $($('#tablaPedidos').DataTable().table().container());
    this.txtPedido = $('#txtPedido');
    this.txtCliente = $('#txtCliente');
    this.txtNomCliente = $('#txtNomCliente');
    this.campRefer = $('#campRefer');
    this.refCant = $('#campCant');
    this.selectType = document.getElementById('selectType');
    this.inpCodTransportista = document.getElementById('codTransportistaInput');
    this.inpCodVehiculo = document.getElementById('codVehiculoInput');
    this.btnTransporterSearch = document.getElementById('transporterSearch');
    this.btnVehicleSearch = document.getElementById('vehicleSearch');
    this.btnEnvioAceptar = document.getElementById('envioAceptar');
    this.bultosInput = document.getElementById('bultosInput');
    this.pesoInput = document.getElementById('pesoInput');
    this.etiquetasInput = document.getElementById('etiquetasInput');
    this.AlbValContainer = document.getElementById('AlbValContainer');
    this.chkAlbaranVal = document.getElementById('chkAlbaranVal');
}
Expedicion.prototype.initialize = function () {

    exp.v_tabla = $('#tablaPedidos').DataTable();

    exp.v_lineas = exp.v_tabla.rows().data();
};

Expedicion.prototype.NuevoPedido = function () {
    exp.detallesProd = [];
    exp.v_lineas_pedido = [];
    exp.bulto = [];
    exp.v_bultos = [];
    exp.v_orden_exp = new Array();
    exp.v_numBulto = 0;
    exp.dialogOpening = false;
    exp.v_albaranSeleccionado = null;
    exp.v_tabla.clear().draw();
    $(exp.campRefer).val("");
    exp.txtCliente.val("");
    exp.txtNomCliente.val("");
};

Expedicion.prototype.Clear = function () {
    $(exp.txtPedido).val("").focus().select();
    exp.NuevoPedido();
};

Expedicion.prototype.ObtenerPedido = function (e) {
    // RBM 03/03/20 Cambio la validación con la pulsación del Intro para hacerla con el evento 'change'
    //if (e.which === 13) {
    {
        exp.NuevoPedido();
        $('#txtPedido').val($('#txtPedido').val().toUpperCase());
        var url = "expedicion/pedido";
        var datos = { empgrupo_cod: sessionStorage.getItem("EMPRGRUP_COD"), emp_cod: sessionStorage.getItem("EMPR_COD"), lecturaPedido: $('#txtPedido').val() };
        var method = "GET";
        var success = function (response) {
            $(exp.AlbValContainer).hide();
            var Ok = function () {
                exp.MostrarAlbaranValorado = response.Objeto.MostrarAlbaranValorado;
                $(exp.chkAlbaranVal).prop('checked', response.Objeto.AlbaranValorado);
                exp.txtCliente.val(response.Objeto.GGCLIPR_COD);
                exp.txtNomCliente.val(response.Objeto.GGCLIPR_NOMBRE);

                exp.dataAux = response.Objeto;
                n_albaranes = exp.dataAux.Albaranes.length;
                if (exp.dataAux.OBSER && exp.dataAux.OBSER.trim() !== "") {
                    lanzarMensaje(response.Ok, exp.dataAux.OBSER, exp.ObservFunc);
                } else {
                    exp.LanzarEnvios();
                }
            };
            var error = function () {
                $('#txtPedido').focus().select();
            };
            handleResponse(response, Ok, error);
        };

        apiGeneral(url, method, datos, success);

        $(this).blur();
        e.preventDefault();
    }
};

Expedicion.prototype.ArticleData = function () {
    var selectedRow = exp.v_tabla.row('.selected')[0];
    $('#descArticulo').val(exp.v_tabla.rows(selectedRow).data()[0].GAART_DESCRIP);
    $('#ref #campRefer').val(exp.v_tabla.rows(selectedRow).data()[0].GAART_COD);

    var LotUbic = $('#tablaPedidos').DataTable().row(selectedRow).data().GAART_LOTES_SN + $('#tablaPedidos').DataTable().row(selectedRow).data().GAART_UBIC_SN;
    var N_lin = $('#tablaPedidos').DataTable().row(selectedRow).data().N_LIN;
    $($('#tablaPedidos').DataTable().row(selectedRow).node()).addClass(LotUbic).prop("id", N_lin);
    row = $(exp.v_tabla.row(selectedRow).node());
    exp.ControlLotUb(row);
};

Expedicion.prototype.SelectArticle = function () {
    exp.ArticleData();
    if (exp.v_lineas.length > 0) {
        if (!exp.dialogOpening) {
            var tableRow = $(exp.v_tabla.row('.selected').node());

            //Si no tiene control de lotes ni ubicaciones seguira por la función
            exp.ControlLotUb(tableRow);

            //si no, seguira adelante
            if (!tableRow.hasClass('NN')) {
                exp.dialogOpening = true;
                exp.v_posicion_pedido = eval($('#tablaPedidos').DataTable().row(tableRow).data().N_LIN);
                for (i = 0; i < exp.v_lineas.length; i++) {
                    if (!exp.v_lineas_pedido[i]) {
                        exp.v_lineas_pedido.push({ 'C_UNI1': 0, 'N_LIN': eval(exp.v_lineas[i].N_LIN) });
                    }
                }
                exp.v_lineas = exp.v_tabla.rows().data();
                exp.v_pedidoActual_cant = 0;
                exp.detallesProd = [];
                exp.v_cant_linea = exp.v_tabla.rows(tableRow).data()[0].C_PDTE;
                exp.v_control_lote_ubic = 'SS';
                var v_dialog = "#dialogLoV";
                var v_nombre_tabla = 'tablaUbicaciones';
                var v_column = [
                    generateColumn('GAUBIC_COD', Resources.table_head_location),
                    generateColumn('LOTE', Resources.table_head_batch),
                    generateColumn('C_UNI1', Resources.table_head_available, true, true)
                ];
                var columnDefs = [
                    { "width": "6em", "targets": 0 },
                    { "width": "4em", "targets": 2 }
                ];

                var id = exp.BuscarLineaPedido(tableRow.prop('id'));

                if (!tableRow.hasClass('SS')) {
                    var col = tableRow.hasClass('NS') ? true : false;
                    if (col) {
                        exp.v_control_lote_ubic = 'NS';
                        v_column = [
                            generateColumn('GAUBIC_COD', Resources.table_head_location),
                            generateColumn('LOTE', Resources.table_head_batch, false),
                            generateColumn('C_UNI1', Resources.table_head_available, true, true)
                        ];
                        columnDefs = [
                            { "width": "4em", "targets": 2 }
                        ];
                    } else {
                        exp.v_control_lote_ubic = 'SN';
                        v_column = [
                            generateColumn('GAUBIC_COD', Resources.table_head_location, false),
                            generateColumn('LOTE', Resources.table_head_batch),
                            generateColumn('C_UNI1', Resources.table_head_available, true, true)
                        ];
                        columnDefs = [
                            { "width": "4em", "targets": 2 }
                        ];
                    }
                }

                //var url = Router.action('Dialog', 'Dialog');
                var url = "Dialog/Dialog";

                var inputs =
                    [
                        generateSingleInput(4, Resources.label_ubicacion, 'txtUbic', '', 'campUbicacion', 'focusable'),
                        generateSingleInput(5, Resources.label_lote, 'txtLote', '', 'campLote', 'focusable'),
                        generateSingleInput(3, Resources.label_quantity_shrt, 'txtCant', '', 'campCant', 'focusable text-right', true)
                    ];
                var upperInputs =
                    [
                        generateSingleInput(4, Resources.label_ref, 'txtRef', exp.v_tabla.rows(tableRow).data()[0].GAART_COD, 'campRef', null, null, null, true),
                        generateSingleInput(5, Resources.label_description, 'txtDescrip', exp.v_tabla.rows(tableRow).data()[0].GAART_DESCRIP, 'campDescrip', null, null, null, true),
                        generateSingleInput(3, Resources.label_pending, 'txtPdte', '', 'campPdte', 'text-right', null, null, true)
                    ];
                var buttons = [{ id: 'aceptar', value: Resources.button_accept }];

                generarDialogAuto(url, v_dialog, v_nombre_tabla, null, exp.v_dataClon.Lineas[id].Existencias, v_column, buttons, inputs, upperInputs, exp.SelectUbicacion, Resources.title_location, ['dialogPedidos2'], null, null, Resources.table_zeroRecordsMessage_no_stock, null, false, columnDefs);
            }
        }
    } else {
        $('#confirmar').prop('disabled', true);
    }
};

Expedicion.prototype.SearchByRef = function (e) {
    // RBM 03/03/20 Cambio la validación con la pulsación del Intro para hacerla con el evento 'change'
    //if (e.which === 13) {
    {
        if (!exp.BuscarProducto() && $('#tablaPedidos').DataTable().rows().data().length > 0) {
            var url = "expedicion/Articulos";
            var datos = { empgrupo_cod: sessionStorage.getItem("EMPRGRUP_COD"), emp_cod: sessionStorage.getItem("EMPR_COD"), codigoBarras: $('#campRefer').val() };
            var method = "GET";
            var success = function (response) {
                var Ok = function () {
                    var v_articulos = response.Objeto;
                    obtenerCodBarras($('#campRefer'));

                    //En caso de que haya más de un producto con el mismo código en la DB
                    if (v_articulos.length > 1) {
                        v_articulos = exp.ProductosMultiples(v_articulos);
                    }
                    if (v_articulos.length === 1) {
                        $('#campRefer').val(v_articulos[0].GAART_COD);
                        if (!exp.BuscarProducto()) {
                            lanzarMensaje(false, Resources.error_article_not_found);
                        }
                    } else if (v_articulos.length === 0) {
                        lanzarMensaje(response.Ok, Resources.error_ref_incorrect);
                    }
                };
                var error = function () {
                    $('#campRefer').focus().select();
                };
                handleResponse(response, Ok, error);
            };
            apiGeneral(url, method, datos, success);
        } else if ($('#tablaPedidos').DataTable().rows().data().length === 0) {
            lanzarMensaje(false, Resources.error_select_order, function () { txtPedido.focus().select(); });
        } else if ($('#tablaPedidos').DataTable().rows().data().length > 1) {
            var tableData = $('#tablaPedidos').DataTable().rows().data();
            var data = [];
            tableData.each(function (d) {
                if (d.GAART_COD === $('#campRefer').val()) {
                    data.push(d);
                }
            });
            exp.ProductosMultiples(data);
        } else {
            console.log("Error en productos multiples");
        }
        $(e.target).blur();
        e.preventDefault();
    }
};

Expedicion.prototype.Confirmar = function () {
    exp.DejarPendiente = false;
    exp.RealizarConfirmacion();
};

Expedicion.prototype.RealizarConfirmacion = function () {
    if (!exp.dialogOpening && exp.data) {
        exp.RecogerDatos();
        if ($('#campCant').val().trim() === "") {
            var vacio = true;
            if (exp.v_orden_exp.length !== 0) {
                for (i = 0; i < exp.v_orden_exp.LINEAS.length; i++) {
                    if (exp.v_orden_exp.LINEAS[i].C_UNI1 !== 0) {
                        vacio = false;
                    }
                }
            }
            if (!vacio) {
                exp.TransformExpedicion();

                var url = "expedicion/resumenbultos";
                var datos = exp.v_orden_exp;
                var method = "PUT";
                var success = function (response) {
                    var Ok = function () {
                        showDialog("#dialogEnviosEtiquetas");
                        $('.datosEnvio').hide();
                        $('#bultosInput').val(response.Objeto.N_BULTOS);
                        $('#pesoInput').val(response.Objeto.PESO);
                        $('#etiquetasInput').val(response.Objeto.N_ETIQUETAS);
                        $('.datosEtiquetas').show();
                        exp.MostrarAlbaranValorado ? $(exp.AlbValContainer).show() : $(exp.AlbValContainer).hide();
                        $("#codTransportistaInput").focus().select();
                        exp.Opciones = response.Objeto.Opciones;
                        exp.v_orden_exp.N_COPIAS = response.Objeto.N_COPIAS;
                        exp.GestionaCopias();

                        $(exp.selectType).empty();
                        $.each(exp.Opciones, function (i, Obj) {
                            $(exp.selectType).append($('<option>', {
                                value: Obj,
                                text: Obj
                            }));
                        });
                        $(exp.selectType).val(response.Objeto.OpcionPredeterminada);
                    };
                    handleResponse(response, Ok);
                };

                apiGeneral(url, method, datos, success);
            } else {
                lanzarMensaje(false, Resources.error_prep_pedido);
            }
        }
    }
};

Expedicion.prototype.ContinuarExped = function () {
    exp.DatosEnvio();
    exp.GenerarExpedicion();
};
Expedicion.prototype.ContinuarImpr = function () {
    exp.DatosEnvio();
    exp.GenerarExpedicion();
};
Expedicion.prototype.ClearCode = function () {
    exp.v_code = "";
};

Expedicion.prototype.EnvioConfirmar = function () {
    exp.expedir();
    $('#dialogEnviosEtiquetas #codTransportistaInput').prop("value", $('#codTransporte').val());
    $('#dialogEnviosEtiquetas #nombreTransportistaInput').prop("value", $('#nombreTransporte').val());
    $('#dialogEnviosEtiquetas #codVehiculoInput').prop("value", $('#codVehiculo').val());
    $('#dialogEnviosEtiquetas #descrVehiculoInput').prop("value", $('#descrVehiculo').val());
    $('.transp').addClass('half');
};

Expedicion.prototype.BuscarLineaPedido = function (id) {
    for (i = 0; i < exp.data.Lineas.length; i++) {
        if (TryParseInt(exp.data.Lineas[i].N_LIN, -1) === TryParseInt(id, -2)) {
            return i;
        }
    }
};

Expedicion.prototype.CantSinLotUb = function () {
    var selexpf = this;
    exp.v_tabla = $('#tablaPedidos').DataTable();
    exp.v_posicion_pedido = eval($('#tablaPedidos').DataTable().row('.selected').data().N_LIN);
    var v_cantVal = TryParseInt($('#ref #campCant').val().trim(), 0);

    if (v_cantVal !== 0) {
        dialogOpening = true;
        for (i = 0; i < exp.v_lineas.length; i++) {
            if (!exp.v_lineas_pedido[i]) {
                exp.v_lineas_pedido.push({ 'C_UNI1': 0, 'N_LIN': eval(exp.v_lineas[i].N_LIN) });
            }
        }
        exp.detallesProd = [];
        var posicion = exp.BuscarLineaPedido(exp.v_tabla.row('.selected').data().N_LIN);
        var existencias = 0;
        var v_existencias = exp.data.Lineas[posicion].Existencias;
        for (i = 0; i < v_existencias.length; i++) {
            existencias = existencias + v_existencias[i].C_UNI1;
        }
        var v_cantidad = eval(v_cantVal);
        exp.v_pedidoActual_cant = 0;
        exp.ModCantidades(existencias, v_cantidad, eval(exp.v_tabla.row('.selected').data().C_PDTE));
        exp.LanzarVentanaBultos("#dialogLoV");
        $('#ref #campCant').val("");
    }
};

Expedicion.prototype.ControlLotUb = function (JQInput) {
    if (JQInput.hasClass('NN')) {
        $('#txtRefer').removeClass('col-xs-10');
        $('#txtRefer').addClass('col-xs-5');
        $('.sinLote').show();
        // RBM $('#ref #campCant').focus();
        document.tabulado.siguiente($('#ref #campCant'));
        if (typeof v_code !== 'undefined' && v_code !== "" && v_code.obtenerIdentificadores.length > 0) {
            for (i = 0; i < v_code.obtenerIdentificadores.length; i++) {
                var ia = TryParseInt(v_code.obtenerIdentificadores[i].ia);
                if (ia === 37) {
                    $('#ref #campCant').val(v_code.obtenerIdentificadores[i].valor);
                }
            }
        }
        resizePedidos();
    } else {
        $('#txtRefer').addClass('col-xs-10');
        $('#txtRefer').removeClass('col-xs-5');
        $('.sinLote').hide();
    }
};

Expedicion.prototype.BuscarProducto = function () {
    for (i = 0; i < exp.v_tabla.rows().data().length; i++) {
        if (exp.v_tabla.row(i).data().GAART_COD === $('#campRefer').val().trim()) {
            exp.v_tabla.row('.selected').nodes().to$().removeClass('selected');
            exp.v_tabla.row(i).nodes().to$().addClass('selected');
            $('#tablaPedidos .selected').click();
            return true;
        }
    }
    return false;
};

Expedicion.prototype.SeleccionProdRepetido = function () {
    $('#dialogLoV #accept').on('click', function () {
        var searchArray = [
            { KEY: "GAART_COD", VALUE: $('#LoVTable').DataTable().row('.selected').data().GAART_COD },
            { KEY: "GAART_DESCRIP", VALUE: $('#LoVTable').DataTable().row('.selected').data().GAART_DESCRIP }
        ];
        seleccionFila("#tablaPedidos", searchArray);
        $('#campRefer').val($('#LoVTable').DataTable().row('.selected').data().GAART_COD);
        closeModal('#dialogLoV');
        //$('#campRefer').trigger(jQuery.Event('keypress', { which: 13 }));
        exp.SelectArticle();
    });
};

Expedicion.prototype.ProductosMultiples = function (v_articulos) {
    //En caso de que haya más de un producto con el mismo código en el pedido
    if (v_articulos.length > 1) {
        //var url = Router.action('Dialog', 'Dialog');
        var url = "Dialog/Dialog";
        var v_columns = [generateColumn('GAART_COD', Resources.table_head_code), generateColumn('GAART_DESCRIP', Resources.table_head_description)];
        var columnDefs = [
            { width: '6em', targets: 0 }
        ];
        var v_buttons = [generateSingleButton('accept', Resources.button_accept)];
        generarDialogAuto(url, '#dialogLoV', 'LoVTable', null, v_articulos, v_columns, v_buttons, null, null, exp.SeleccionProdRepetido, Resources.title_multiple_products, null, Resources.message_multiple_products, null, null, null, null, columnDefs);
    }
    return v_articulos;
};

Expedicion.prototype.ObservFunc = function () {
    exp.LanzarEnvios();
};

Expedicion.prototype.LanzarEnvios = function () {
    $('#codTransportistaInput').val(exp.dataAux.GGMENVIO_COD);
    $('#nombreTransportistaInput').val(exp.dataAux.GGMENVIO_DESCRIP);
    $('#codVehiculoInput').val(exp.dataAux.GGVEHICULO_COD);
    $('#descrVehiculoInput').val(exp.dataAux.GGVEHICULO_DESCRIP);
    if (exp.dataAux.DatosEnvioInicial) {
        showDialog("#dialogEnviosEtiquetas");
        $('.datosEnvio').show();
        $('#envioContent').addClass("blank-space");
        $('.datosEtiquetas').hide();
        // RBM $("#codTransportistaInput").focus().select();
        document.tabulado.siguiente($('#codTransportistaInput'));
        
    } else {
        exp.DatosEnvio();
        lanzarAlbaranes();
    }
};

Expedicion.prototype.Pendiente = function () {
    exp.DejarPendiente = true;
    exp.RealizarConfirmacion();
};

Expedicion.prototype.SelectAlbaran = function () {
    // Para cambios de albarán en medio de un pedido en proceso
    $('#tablaAlbaranes').on('dblclick', function () {
        exp.SeleccionAlbaran();
        closeModal('#dialogLoV');
    });

    $('#seleccionarAlbaran').on("click", function () {
        exp.SeleccionAlbaran();
        closeModal('#dialogLoV');
    });

    $('#nuevoAlbaran').on("click", function () {
        exp.DatosAlbaran("", "", "");
        closeModal('#dialogLoV');
    });
};

Expedicion.prototype.SelectAlbaranPintarPed = function () {
    // Selección de albarán que añade los datos del pedido a la tabla
    $('#tablaAlbaranes').on('dblclick', function () {
        exp.SeleccionAlbaran();
        exp.PintarTablaPedidos();
        closeModal('#dialogLoV');
    });

    $('#seleccionarAlbaran').on("click", function () {
        exp.SeleccionAlbaran();
        exp.PintarTablaPedidos();
        closeModal('#dialogLoV');
    });

    $('#nuevoAlbaran').on("click", function () {
        exp.DatosAlbaran("", "", "");
        exp.PintarTablaPedidos();
        closeModal('#dialogLoV');
    });
};

Expedicion.prototype.DatosAlbaran = function (tipoAlbaran, numAlbaran, fechaAlbaran) {
    // Recoge los datos del albaran y actualiza los datos en el menú
    $('#tipoAlbaran').val(tipoAlbaran);
    $('#numAlbaran').val(numAlbaran);
    $('#confirmar').prop('disabled', false);
    $('#dialogAlbaranes').modal('hide');
    var v_fecha = fechaAlbaran === "" ? new Date() : new Date(fechaAlbaran);
    updateDatePicker(v_fecha);
    exp.CambioAlbaran();
};

Expedicion.prototype.SeleccionAlbaran = function () {
    if ($('#tablaAlbaranes').DataTable().rows()[0].length > 0) {
        exp.v_albaranSeleccionado = $('#tablaAlbaranes').DataTable().row('.selected').data();
        var v_albaran_seleccionado = $('#tablaAlbaranes').DataTable().rows('.selected').data()[0];
        var v_tipoAlbaran = v_albaran_seleccionado.GGALBTIP_COD;
        var v_numAlbaran = v_albaran_seleccionado.N_ALBARAN;
        var v_fechaAlbaran = v_albaran_seleccionado.F_ALBARAN_HID;
        exp.DatosAlbaran(v_tipoAlbaran, v_numAlbaran, v_fechaAlbaran);
        exp.CambioAlbaran();
    }
};

Expedicion.prototype.PintarTablaPedidos = function () {
    exp.data = exp.dataAux;

    // Clon de data para que los datos no sean modificados 
    // en el caso de que se cancele la operación
    exp.v_dataClon = JSON.parse(JSON.stringify(exp.data));

    exp.initialize();
    exp.GenerarMenu();

    var v_table = $('#tablaPedidos').DataTable();
    v_table.clear().draw();
    if (v_table.rows.length === 0) {
        v_table.rows.add(exp.data.Lineas).draw();
        exp.v_lineas = v_table.rows().data();
        selectRow('#tablaPedidos');
    }
    $('#menuObservaciones').show();

    $('#txtRefer').addClass('col-xs-10');
    $('#txtRefer').removeClass('col-xs-5');
    $('.sinLote').hide();

    $('#campRefer').val("").get(0).focus();
    // Si el pedido tiene alguna observación
    if (exp.data.OBSER) {
        $('#menuObservaciones input').val(Resources.menu_show);
    } else {
        $('#menuObservaciones input').val(Resources.menu_no_observations);
    }

    // Si el albarán no es nuevo
    if (typeof v_albaranSeleccionado !== 'undefined') {
        var refAlb = v_albaranSeleccionado.SU_REF_ALB;
        $('#menuRefAlbaran input').val(refAlb);
        $('#codRefAlbaran').val(refAlb);
    }
    closeModal("#dialogAlbaranes");
};


Expedicion.prototype.CambioAlbaran = function () {
    // Actualiza el menú desplegable con el albarán seleccionado
    if ($("#tipoAlbaran").val() !== "" && $("#numAlbaran").val() !== "") {
        v_albaran = $("#tipoAlbaran").val() + "-" + $("#numAlbaran").val();
    } else {
        v_albaran = Resources.menu_new;
    }
    $('#menuAlbaran div input').val(v_albaran);
};

Expedicion.prototype.GestionaCopias = function () {
    if (exp.DejarPendiente) {
        $('#CopiasInput').val(exp.v_orden_exp.N_COPIAS);
        $('.copiasField').show();
    } else {
        $('.copiasField').hide();
    }
};

Expedicion.prototype.GenerarMenu = function () {
    exp.CambioAlbaran();

    exp.MenuInit();
    menuElement(Resources.menu_delivery_note_date, 'fecha', '#', dateToString(getDateAlb(exp.v_albaranSeleccionado)), 'buscador', 'menuDate');
    menuElement(Resources.menu_delivery_note_change, 'observaciones', '#', v_albaran, 'buscador', 'menuAlbaran');
    menuElement('Ref. Albarán', 'observaciones', '#', 'Sin ref.', '', 'menuRefAlbaran');
    menuElement(Resources.menu_observations, 'observaciones', '#', "Mostrar", '', 'menuObservaciones');

    menuDatePicker();

    $("#tipoAlbaran").bind("change paste keyup", function () {
        exp.CambioAlbaran();
    });
    $("#numAlbaran").bind("change paste keyup", function () {
        exp.CambioAlbaran();
    });

    $('#menuAlbaran').on('click', function () {
        if (typeof exp.data !== 'undefined') {
            //var url = Router.action('Dialog', 'Dialog');
            var url = "Dialog/Dialog";
            var v_columns = [
                generateColumn('GGALBTIP_COD', Resources.table_head_type),
                generateColumn('N_ALBARAN', Resources.table_head_number, true, true),
                generateColumn('F_ALBARAN', Resources.table_head_date),
                generateColumn('GGESTADO_COD', Resources.table_head_state),
                generateColumn('F_ALBARAN_HID', '', false)
            ];

            var columnDefs = [
                { "width": "4em", "targets": 0 },
                { "width": "4em", "targets": 1 },
                { "width": "2em", "targets": 3 }
            ];
            var buttons = [generateSingleButton('seleccionarAlbaran', Resources.button_select, 'pull-right'), generateSingleButton('nuevoAlbaran', Resources.button_new, 'pull-left')];
            var v_albaranes = exp.data.Albaranes.map(function (albaran) {
                return {
                    GGALBTIP_COD: albaran.GGALBTIP_COD,
                    N_ALBARAN: albaran.N_ALBARAN,
                    //Fecha formateada para su visualización
                    F_ALBARAN: moment(albaran.F_ALBARAN).format(Globalize($("html").attr("lang")).culture().calendar.patterns.d.toUpperCase()),
                    GGESTADO_COD: albaran.GGESTADO_COD,
                    //Fecha sin formatear (Oculto)
                    F_ALBARAN_HID: albaran.F_ALBARAN,
                    SU_REF_ALB: albaran.SU_REF_ALB
                };
            });
            generarDialogAuto(url, "#dialogLoV", 'tablaAlbaranes', null, v_albaranes, v_columns, buttons, null, null, exp.SelectAlbaran, Resources.title_delivery_note_selection, null, null, null, null, null, null, columnDefs);
        }
    });

    $('#menuObservaciones').on('click', function () {
        if (exp.data) {
            if (exp.data.OBSER && exp.data.OBSER.trim() !== "")
                lanzarMensaje(true, exp.data.OBSER);
            else
                lanzarMensaje(true, Resources.message_no_observations);
        } else {
            lanzarMensaje(false, Resources.error_insert_order);
        }
    });
};


var exp;



function restartData() {
    exp.v_dataClon = JSON.parse(JSON.stringify(exp.data));
    $("#campRefer").focus().select();
}
function lanzarAlbaranes() {
    //var url = Router.action('Dialog', 'Dialog');
    var url = "Dialog/Dialog";
    var v_columns = [
        generateColumn('GGALBTIP_COD', Resources.table_head_type),
        generateColumn('N_ALBARAN', Resources.table_head_number, true, true),
        generateColumn('F_ALBARAN', Resources.table_head_date),
        generateColumn('GGESTADO_COD', Resources.table_head_state),
        generateColumn('F_ALBARAN_HID', '', false)
    ];

    var inputs = [
        generateSingleInput('12', 'Buscar albarán', 'txtBuscaAlbaran', '', '', 'focusable code')
    ];
    var columnDefs = [
        { "width": "4em", "targets": 0 },
        { "width": "4em", "targets": 1 },
        { "className": "dt-center", "targets": 2 },
        { "width": "2em", "targets": 3 }
    ];
    var buttons = [generateSingleButton('seleccionarAlbaran', Resources.button_select, 'pull-right'), generateSingleButton('nuevoAlbaran', Resources.button_new, 'pull-left', 'gray')];
    if (exp.dataAux.Albaranes.length !== 0) {
        var v_albaranes = exp.dataAux.Albaranes.map(function (albaran) {
            return {
                GGALBTIP_COD: albaran.GGALBTIP_COD,
                N_ALBARAN: albaran.N_ALBARAN,
                //Fecha formateada para su visualización
                F_ALBARAN: moment(albaran.F_ALBARAN).format(Globalize($("html").attr("lang")).culture().calendar.patterns.d.toUpperCase()),
                GGESTADO_COD: albaran.GGESTADO_COD,
                //Fecha sin formatear (Oculto)
                F_ALBARAN_HID: albaran.F_ALBARAN
            };
        });
        var fnAlbaran = function () {
            $('#txtBuscaAlbaran').focus();
            $('#txtBuscaAlbaran').keypress(function (e) {
                if (e.which === 13) {
                    var url = "/Expedicion/NumeroAlbaran";
                    var method = "GET";
                    var data = {
                        empgrupo_cod: sessionStorage.getItem("EMPRGRUP_COD"),
                        emp_cod: sessionStorage.getItem("EMPR_COD"),
                        lectura_albaran: $('#txtBuscaAlbaran').val()
                    };
                    var success = function (response) {
                        var Ok = function () {
                            var GGALBTIP_COD = response.Objeto.GGALBTIP_COD;
                            var N_ALBARAN = response.Objeto.N_ALBARAN;

                            var searchArray = [
                                { KEY: "GGALBTIP_COD", VALUE: GGALBTIP_COD },
                                { KEY: "N_ALBARAN", VALUE: N_ALBARAN }
                            ];
                            var found = seleccionFila("#tablaAlbaranes", searchArray);
                            if (!found) lanzarMensaje(false, "No se ha encontrado el albarán introducido", function () { $('#txtBuscaAlbaran').focus().select(); });
                            else $('#seleccionarAlbaran').click();
                        };
                        var error = function () {
                            lanzarMensaje(false, "No se ha encontrado el albarán introducido", function () { $('#txtBuscaAlbaran').focus().select(); });
                        };
                        handleResponse(response, Ok, error);
                    };
                    apiGeneral(url, method, data, success);
                }
            });
            exp.SelectAlbaranPintarPed();
        };
        generarDialogAuto(url, "#dialogLoV", 'tablaAlbaranes', null, v_albaranes, v_columns, buttons, null, inputs, fnAlbaran, Resources.title_delivery_note_selection, null, null, null, null, null, false, columnDefs);
    } else {
        exp.DatosAlbaran("", "", "");
        exp.PintarTablaPedidos();
    }
}


Expedicion.prototype.SelectUbicacion = function () {
    var v_table = $('#tablaUbicaciones').DataTable();

    var txtCant = $('#txtCant');
    var txtLote = $('#txtLote');
    var txtUbic = $('#txtUbic');
    var btnAccept = document.getElementById('aceptar');
    addEvent(btnAccept, 'click', confirmarUbicaciones, false);
    $('#tablaUbicaciones tbody').on('click', ubicationData);

    // RBM 03/03/20 Cambio la validación con la pulsación del Intro para hacerla con el evento 'change'
    //txtUbic.keypress(function (e) {
    //    if (e.which === 13) {
    txtUbic.on("change", function (e) {
        {
            if ($(this).val() !== "") {
                getUbic();
                setTimeout(function () {
                    focusCant();
                    focusLote();
                });
                e.preventDefault();
            }
        }
    });

    // RBM 03/03/20 Cambio la validación con la pulsación del Intro para hacerla con el evento 'change'
    //txtLote.keypress(function (e) {
    //    if (e.which === 13) {
    txtLote.on("change", function (e) {
        {
            if ($(this).val() !== "") {
                getLote();
                focusCant();
                e.preventDefault();
            }
        }
    });

    // RBM 03/03/20 Cambio la validación con la pulsación del Intro para hacerla con el evento 'change'
    //txtCant.keypress(function (e) {
    //    if (e.which === 13) {
    txtCant.on("change", function (e) {
        {
            if ($(this).val()) exp.Ubicacion();
        }
    });

    function ubicationData() {
        if (v_table.rows()[0].length > 0) {
            var selectedRow = v_table.row('.selected')[0];
            $('#txtUbic').val(v_table.rows(selectedRow).data()[0].GAUBIC_COD);
            $('#txtLote').val(v_table.rows(selectedRow).data()[0].LOTE);

            var pendiente = $("#txtPdte").val();
            var cantidadEnUbic = v_table.row(selectedRow).data().C_UNI1;
            $('#txtCant').val(setOptimumQty(pendiente, cantidadEnUbic));
        }
    }

    function getUbic() {
        var arrayBusqueda = [];
        arrayBusqueda.push({ KEY: 'GAUBIC_COD', VALUE: $('#txtUbic').val() });
        var existeFila = seleccionFila("#tablaUbicaciones", arrayBusqueda);
        if (exp.v_control_lote_ubic === 'NS') {
            if (existeFila) $('#tablaUbicaciones .selected').click();
        } else {
            setUbicLote();
        }
    }

    function getLote() {
        var arrayBusqueda = [];
        if (exp.v_control_lote_ubic === 'SN') {
            arrayBusqueda.push({ KEY: 'LOTE', VALUE: $('#txtLote').val() });
        } else {
            arrayBusqueda.push({ KEY: 'GAUBIC_COD', VALUE: $('#txtUbic').val() }, { KEY: 'LOTE', VALUE: $('#txtLote').val() });
        }
        var existeFila = seleccionFila("#tablaUbicaciones", arrayBusqueda);
        if (existeFila) $('#tablaUbicaciones .selected').click();
    }
    function resetFocus() {
        if (exp.v_control_lote_ubic === 'SN') {
            $('#txtLote').focus().select();
        } else {
            $('#txtUbic').focus().select();
        }
    }

    //txtLote.blur(function () {
    //    if (v_control_lote_ubic == 'SN') {
    //        seleccionFila("#tablaUbicaciones", "", $(this).val());
    //    } else {
    //        seleccionFila("#tablaUbicaciones", $('#txtUbic').val(), $(this).val());
    //    }
    //    clickOnSelected();
    //});
    function focusUbic() {
        txtUbic.focus().select();
    }

    function focusLote() {
        txtLote.focus().select();
    }

    function focusCant() {
        txtCant.focus().select();
    }

    exp.dialogOpening = false;
    cambioTamanioPed();

    if (exp.v_control_lote_ubic === 'SN') {
        $('#campUbicacion').hide();
        $('#campLote').removeClass('col-xs-5');
        $('#campLote').addClass('col-xs-7');
        $('#campCant').removeClass('col-xs-3');
        $('#campCant').addClass('col-xs-5');
    } else if (exp.v_control_lote_ubic === 'NS') {
        $('#campLote').hide();
        $('#campUbicacion').removeClass('col-xs-4');
        $('#campUbicacion').addClass('col-xs-7');
        $('#campCant').removeClass('col-xs-3');
        $('#campCant').addClass('col-xs-5');
    }
    $("#txtPdte").val(exp.v_cant_linea);


    $('#tablaUbicaciones').on("click", "tr", function () {
        var table = $('#tablaUbicaciones').DataTable();
        if (table.rows()[0].length > 0) {
            setUbicLote();
            txtCant.focus();
        } else {
            focusLote();
            focusUbic();
        }
    });

    function confirmarUbicaciones() {
        // RBM 03/03/20 Cambio la validación con la pulsación del Intro para hacerla con el evento 'change'
        //var e = jQuery.Event("keypress");
        //e.which = e.keyCode = 13;
        var e = jQuery.Event("change");
        $(txtCant).trigger(e);

        if (exp.v_pedidoActual_cant !== 0) {
            if (!exp.data.BultosPorLinea) {
                exp.RecogerDetalles();
                exp.dialogOpening = false;
                closeModal("#dialogPedidos2");
                closeModal("#dialogLoV");
            } else {
                exp.LanzarVentanaBultos();
            }
            $('#campRefer').val("");
        }
    }

    $('#dialogPedidos').on('shown.bs.modal', function () {
        code();
    });

    $('#dialogMessage').on('hidden.bs.modal', function () {
        $(btnAccept).prop('disabled', false);
        txtLote.focus();
    });


    $('#dialogLoV .close').on("click", function () {
        restartData();
    });

    //Intentará hacer focus en lote y ubicación, si uno no existe, hará focus en el otro
    //Si existen los 2, hará focus en ubicación
    focusLote(); focusUbic();
    function setUbicLote() {
        if (v_table.rows().count() !== 0) {
            $('#txtUbic').val(v_table.row('.selected').data().GAUBIC_COD);
            $('#txtLote').val(v_table.row('.selected').data().LOTE);
        }
    }
};

Expedicion.prototype.Reset = function () {
    if (exp.v_control_lote_ubic === 'SN') {
        $('#txtLote').focus().select();
    } else {
        $('#txtUbic').focus().select();
    }
};

//$(window).resize(function () {
//    cambioTamanioPed();
//});

Expedicion.prototype.Ubicacion = function () {
    var cantidad = $('#txtCant').val();
    if ($.isNumeric(cantidad)) {
        cantidad = eval(cantidad);
        if ($('#tablaUbicaciones').DataTable().rows('.selected').data().length > 0) {
            var disponible = eval($('#tablaUbicaciones').DataTable().rows('.selected').data()[0].C_UNI1);
            var pdte = $('#txtPdte').val();
            var table = $("#tablaUbicaciones").DataTable();
            exp.ModCantidades(disponible, eval(cantidad), pdte, table);
            $('#txtCant').val("");
            $('#txtLote').focus();
            $('#txtUbic').focus();

            return true;
        } else {
            $('#txtCant').val("");
            $('#aceptar').prop('disabled', true);
            lanzarMensaje(false, Resources.error_batch_not_found, function () { $('#txtCant').focus(); });
            return false;
        }
    }
}

Expedicion.prototype.ModCantidades = function (disponible, cantidad, pdte, table, ubic, lote) {
    disponible = disponible - cantidad;
    pdte = pdte - cantidad;

    var encontrado = false;
    for (i = 0; i < exp.v_dataClon.Lineas.length && !encontrado; i++) {
        if (TryParseInt(exp.v_dataClon.Lineas[i].N_LIN, -1) === TryParseInt(exp.v_posicion_pedido, -2)) {
            exp.v_dataClon.Lineas[i].C_PDTE = pdte;
            encontrado = true;
        }
    }

    $('#txtPdte').val(pdte);
    $('#txtCant').val("");
    if (table) {
        table.row('.selected').data().C_UNI1 = disponible;
        table.row('.selected').invalidate();
        //table.cell('.selected td:eq(2)').data( disponible);
        ubic = table.rows('.selected').data()[0].GAUBIC_COD;
        lote = table.rows('.selected').data()[0].LOTE;
    }
    var prod = {
        id: eval($('#tablaPedidos').DataTable().rows('#' + exp.v_posicion_pedido).data()[0].N_LIN),
        GAUBIC_COD: ubic,
        LOTE: lote,
        C_UNI1: cantidad
    };

    exp.detallesProd.push(prod);
    exp.v_pedidoActual_cant = exp.v_pedidoActual_cant + cantidad;
};

Expedicion.prototype.LanzarVentanaBultos = function (dialogName) {
    if (exp.data.BultosPorLinea) {
        //var url = Router.action('Dialog', 'Dialog');
        var url = "Dialog/Dialog";
        dialog = "#dialogPedidos2";
        if (dialogName === "#dialogLoV") {
            dialog = dialogName;
        }
        var buttons = [
            generateSingleButton('bultoDetail', Resources.button_details),
            generateSingleButton('bultoNuevo', Resources.button_new),
            generateSingleButton('bultoNing', Resources.button_none),
            generateSingleButton('bultoSelec', Resources.button_select_shrt)
        ];
        var v_columnas = [
            { "mDataProp": "N_BULTO", name: Resources.table_head_bulto },
            { "mDataProp": "v_tipoBulto", name: Resources.table_head_description },
            { "mDataProp": "v_cantidad", name: Resources.table_head_quantity }
        ];
        var columnDefs = [
            { width: '2em', target: 0 },
            { width: '4em', target: 2 }
        ];
        var innerDialogs = ['dialogBultoDetail', 'dialogBultoNuevo'];
        generarDialogAuto(url, dialog, 'tablaBultos', null, exp.bulto, v_columnas, buttons, null, null, exp.FuncionesBultos, Resources.title_packages, innerDialogs, null, null, null, null, null, columnDefs);
    } else {
        dialogOpening = false;
        exp.RecogerDetalles();
    }
};

Expedicion.prototype.LanzarVentanaBultosDetail = function () {
    //var url = Router.action('Dialog', 'Dialog');
    var url = "Dialog/Dialog";
    var buttons = [generateSingleButton('bultoDetailMenu', Resources.button_details, "pull-left"), generateSingleButton('closeDetailMenu', Resources.close)];
    var v_columnas = [
        { "mDataProp": "N_BULTO", name: Resources.table_head_bulto },
        { "mDataProp": "v_tipoBulto", name: Resources.table_head_description },
        { "mDataProp": "v_cantidad", name: Resources.table_head_quantity }
    ];
    var innerDialogs = ['dialogBultoDetailMenu'];
    generarDialogAuto(url, "#dialogLoV", 'tablaBultosDetail', null, exp.bulto, v_columnas, buttons, null, null, funcionesBultosDetail, Resources.title_packages, innerDialogs);
};

Expedicion.prototype.Code = function () {
    if (typeof v_code !== 'undefined' && v_code !== "" && v_code.obtenerIdentificadores.length > 0) {
        for (i = 0; i < v_code.obtenerIdentificadores.length; i++) {
            if (TryParseInt(v_code.obtenerIdentificadores[i].ia, -1) === 10) {
                $('#txtUbic').val("");
                $('#txtLote').val(v_code.obtenerIdentificadores[i].valor);
                $('#txtLote').trigger(jQuery.Event('keypress', { which: 13 }));
            }
            if (TryParseInt(v_code.obtenerIdentificadores[i].ia, -1) === 37) {
                $('#txtCant').val(v_code.obtenerIdentificadores[i].valor);
            }
        }
        $('#detallesUbicacion .selected').click();
        v_code = "";
    }
};