﻿define('bloque',
    [],
    function () {
        function bloque(p_elemento) {
            function DefinicionBloque(p_elemento, p_valores) {
                this.crea = function () {
                    return new Bloque(p_elemento, p_valores);
                };
            }

            function Bloque(p_elemento, p_valores) {
                this.visible = function (p_valor) {
                    if (arguments.length === 0)
                        return !p_elemento.classList.contains('oculto');
                    else {
                        if (p_valor)
                            p_elemento.classList.remove('oculto');
                        else
                            p_elemento.classList.add('oculto');
                    }
                };

                this.clase = function (p_clase, p_activa) {
                    if (p_activa)
                        p_elemento.classList.add(p_clase);
                    else
                        p_elemento.classList.remove(p_clase);
                }

                this.elemento = function () {
                    return p_elemento;
                }
            }

            var v_elemento = p_elemento instanceof HTMLElement ? p_elemento : document.getElementById(p_elemento);
            return new DefinicionBloque(v_elemento, {});
        }

        return bloque;
    });