﻿define('tabla',
    [
        'foco'
    ],
    function (foco) {

        function tabla(p_elemento) {

            function DefinicionTabla(p_selectorTabla, p_valores) {
                this.datos = function (p_datos) {
                    if (arguments.length === 1) {
                        let v_datos = Array.isArray(p_datos) ? p_datos : [];
                        return new DefinicionTabla(p_selectorTabla, Object.assign(p_valores, { datos: v_datos }));
                    }
                    else
                        return p_valores.datos;
                };

                this.columnas = function (p_columnas) {
                    if (arguments.length === 1) {
                        let v_columnas = Array.isArray(p_columnas) ? p_columnas : [];
                        return new DefinicionTabla(p_selectorTabla, Object.assign(p_valores, { columnas: v_columnas }));
                    }
                    else
                        return p_valores.columnas;
                };

                this.opciones = function (p_opciones) {
                    if (arguments.length === 1)
                        return new DefinicionTabla(p_selectorTabla, Object.assign(p_valores, { opciones: p_opciones }));
                    else
                        return p_valores.opciones;
                }

                this.filtro = function (p_filtro) {
                    if (arguments.length === 1)
                        return new DefinicionTabla(p_selectorTabla, Object.assign(p_valores, { filtro: p_filtro }));
                    else
                        return p_valores.filtro;
                }

                this.seleccionado = function (p_seleccionado) {
                    if (arguments.length === 1)
                        return new DefinicionTabla(p_selectorTabla, Object.assign(p_valores, { seleccionado: p_seleccionado }));
                    else
                        return p_valores.seleccionado;
                }

                this.formatoFila = function (p_formato) {
                    if (arguments.length === 1)
                        return new DefinicionTabla(p_selectorTabla, Object.assign(p_valores, { formatoFila: p_formato }));
                    else
                        return p_valores.formatoFila;
                }

                this.crea = function () {
                    //let v_columnasDataTable = tabla._creaColumnasDataTable(p_valores.columnas);
                    //let v_definicionesDataTable = tabla._creaDefinicionesDataTable(p_valores.columnas);

                    ////createTableJson(p_selectorTabla, p_valores.datos, v_columnasDataTable, p_valores.mensajeSinRegistros, v_definicionesDataTable.columnas,
                    ////    false, null, null, false, v_definicionesDataTable.ordenaciones);

                    //let v_opcionesDataTable = {
                    //    "ordering": v_definicionesDataTable.ordenaciones ? true : false,
                    //    "order": v_definicionesDataTable.ordenaciones,
                    //    "data": p_valores.datos,
                    //    "autoWidth": false,
                    //    "columns": v_columnasDataTable,
                    //    "columnDefs": v_definicionesDataTable.columnas,
                    //    "displayLength": 1,
                    //    "responsive": false,
                    //    "pagingType": "simple",
                    //    "scrollY": false,
                    //    "scrollCollapse": true,
                    //    "scrollX": false,
                    //    "deferRender": true,
                    //    "info": false,
                    //    //'select': {
                    //    //    style: 'single',
                    //    //    items: 'rows',
                    //    //    //toggleable: true,
                    //    //    className: 'seleccionado'
                    //    //},
                    //    select: 'single',
                    //    "drawCallback": function () {
                    //        navigateArrows(p_selectorTabla);
                    //        //drawCallbackFn();
                    //    },
                    //    "initComplete": function (settings, json) {
                    //        SpyFilter().applyFilters(p_selectorTabla);
                    //    },
                    //    "rowCallback": function (p_tr, p_objeto, p_displayNum, p_displayIndex, p_dataIndex) {
                    //        if (typeof p_valores.formatoFila === 'function') {
                    //            let v_dataTable = this.api();
                    //            let v_fila = new FormateadorFila(v_dataTable, p_tr, p_displayNum, p_displayIndex, p_dataIndex);
                    //            p_valores.formatoFila(v_fila, p_objeto);
                    //        }

                    //        for (var v_indice = 0; v_indice < p_valores.columnas.length; v_indice++) {
                    //            let v_columna = p_valores.columnas[v_indice];
                    //            let v_td = p_tr.cells[v_indice];
                    //            if (v_columna.editable)
                    //                v_td.classList.add('green');
                    //            else
                    //                v_td.classList.remove('green');
                    //        }
                    //        return;

                    //        //$(table).DataTable().columns.adjust().responsive.rebuild().responsive.recalc();
                    //        return p_tr;
                    //    },
                    //    "language": {
                    //        "sProcessing": "Procesando...",
                    //        "sLengthMenu": Resources.table_length_menu,
                    //        "sZeroRecords": "No se encontraron resultados",
                    //        "sEmptyTable": p_valores.mensajeSinRegistros || Resources.table_no_data,
                    //        "sInfo": Resources.table_sinfo,
                    //        "sInfoEmpty": Resources.table_sinfo_empty,
                    //        "sInfoFiltered": "(filtrado de un total de _MAX_ registros)",
                    //        "sInfoPostFix": "",
                    //        "sSearch": Resources.table_search + ":",
                    //        "sUrl": "",
                    //        "sInfoThousands": ",",
                    //        "sLoadingRecords": Resources.table_loading_records,
                    //        "paginate": {
                    //            "first": "Primero",
                    //            "last": "Último",
                    //            "next": '<i class="glyphicon glyphicon-arrow-right gi-2x"/>',
                    //            "previous": '<i class="glyphicon glyphicon-arrow-left gi-2x"/>',
                    //        },
                    //        "aria": {
                    //            "sSortAscending": ": Activar para ordenar la columna de manera ascendente",
                    //            "sSortDescending": ": Activar para ordenar la columna de manera descendente"
                    //        }
                    //    }
                    //};

                    //let v_dataTable = $(p_selectorTabla)
                    //    .on('error.dt', function (e, settings, techNote, message) {
                    //        lanzarMensaje(false, "Ha ocurrido un error de DT: \n\n" + message);
                    //    })
                    //    .DataTable(v_opcionesDataTable);

                    //$('.dataTables_filter input').addClass('pull-right form-control input-xs');
                    //v_dataTable.page.len(1).draw();
                    ////moveFilter(p_selectorTabla, /*searchField*/null);

                    let v_tabla = new Tabla(p_selectorTabla, p_valores);

                    v_tabla.filtro(p_valores.filtro);
                    return v_tabla;
                };
            }

            class FormateadorFila {
                constructor(p_dataTable, p_row, p_displayNum, p_displayIndex, p_dataIndex) {
                    this.dataTable = p_dataTable;
                    this.row = p_row;
                    this.displayNum = p_displayNum;
                    this.displayIndex = p_displayIndex;
                    this.dataIndex = p_dataIndex;
                }

                fondo(p_color) {
                    let v_colores = { 'verde': 'green', 'rojo': 'red' };
                    let v_color = v_colores[p_color] || `fondo-${p_color}`;
                    this.row.classList.add(v_color);
                }
            }

            function Tabla(p_selectorTabla, p_valores) {
                // la asignación de un nuevo origen de datos a la tabla (propiedad 'datos') provoca cambios en la selección, por lo que sólo se hace la asignación en el
                // caso de que el nuevo origen de datos sea distinto. Para ello guardamos una copia del origen de datos asignado y poder verificar que realmente 
                // el origen cambia al asignarlo a la propiedad 'datos'
                let v_arrayDatos;

                // inicializamos el datatable
                let v_opciones = typeof p_valores.opciones === 'undefined' ? {} : p_valores.opciones;
                let v_columnasDataTable = tabla._creaColumnasDataTable(p_valores.columnas, v_opciones);
                let v_definicionesDataTable = tabla._creaDefinicionesDataTable(p_valores.columnas);

                //createTableJson(p_selectorTabla, p_valores.datos, v_columnasDataTable, p_valores.mensajeSinRegistros, v_definicionesDataTable.columnas,
                //    false, null, null, false, v_definicionesDataTable.ordenaciones);

                let v_opcionesDataTable = {
                    "ordering": v_definicionesDataTable.ordenaciones ? true : false,
                    "order": v_definicionesDataTable.ordenaciones,
                    "data": p_valores.datos,
                    "autoWidth": false,
                    "columns": v_columnasDataTable,
                    "columnDefs": v_definicionesDataTable.columnas,
                    "displayLength": 1,
                    "responsive": false,
                    "pagingType": "simple",
                    "scrollY": false,
                    "scrollCollapse": true,
                    "scrollX": false,
                    "deferRender": true,
                    "info": false,
                    //'select': {
                    //    style: 'single',
                    //    items: 'rows',
                    //    //toggleable: true,
                    //    className: 'seleccionado'
                    //},
                    select: 'single',
                    "drawCallback": function () {
                        navigateArrows(`#${p_selectorTabla.replace(/\./g, '\\.')}`);
                        //drawCallbackFn();
                    },
                    "initComplete": function (settings, json) {
                        SpyFilter().applyFilters(`#${p_selectorTabla.replace(/\./g, '\\.')}`);
                    },
                    "rowCallback": function (p_tr, p_objeto, p_displayNum, p_displayIndex, p_dataIndex) {
                        if (typeof p_valores.formatoFila === 'function') {
                            let v_dataTable = this.api();
                            let v_fila = new FormateadorFila(v_dataTable, p_tr, p_displayNum, p_displayIndex, p_dataIndex);
                            p_valores.formatoFila(v_fila, p_objeto);
                        }

                        for (var v_indice = 0; v_indice < p_valores.columnas.length; v_indice++) {
                            let v_columna = p_valores.columnas[v_indice];
                            let v_td = p_tr.cells[v_indice];
                            if (p_valores.editable && v_columna.editable)
                                v_td.classList.add('green');
                            else
                                v_td.classList.remove('green');
                        }
                        return;
                    },
                    "language": {
                        "sProcessing": "Procesando...",
                        "sLengthMenu": Resources.table_length_menu,
                        "sZeroRecords": "No se encontraron resultados",
                        "sEmptyTable": p_valores.mensajeSinRegistros || Resources.table_no_data,
                        "sInfo": Resources.table_sinfo,
                        "sInfoEmpty": Resources.table_sinfo_empty,
                        "sInfoFiltered": "(filtrado de un total de _MAX_ registros)",
                        "sInfoPostFix": "",
                        "sSearch": Resources.table_search + ":",
                        "sUrl": "",
                        "sInfoThousands": ",",
                        "sLoadingRecords": Resources.table_loading_records,
                        "paginate": {
                            "first": "Primero",
                            "last": "Último",
                            "next": '<i class="glyphicon glyphicon-arrow-right gi-2x"/>',
                            "previous": '<i class="glyphicon glyphicon-arrow-left gi-2x"/>',
                        },
                        "aria": {
                            "sSortAscending": ": Activar para ordenar la columna de manera ascendente",
                            "sSortDescending": ": Activar para ordenar la columna de manera descendente"
                        }
                    }
                };
                // `#${p_selectorTabla.replace(/\./g, '\\.')}`
                //let v_dataTable = $(p_selectorTabla)
                let v_dataTable = $(`#${p_selectorTabla.replace(/\./g, '\\.')}`)
                    .on('error.dt', function (e, settings, techNote, message) {
                        lanzarMensaje(false, "Ha ocurrido un error de DT: \n\n" + message);
                    })
                    .DataTable(v_opcionesDataTable);

                $('.dataTables_filter input').addClass('pull-right form-control input-xs');
                v_dataTable.page.len(1).draw();
                //moveFilter(p_selectorTabla, /*searchField*/null);



                // interceptamos ciertas funciones para notificar de los cambios en el array de datos al DataTable 
                let v_nuevasFunciones = {
                    push: function () {
                        Array.prototype.push.apply(this, arguments);
                        for (let v_indice = 0; v_indice < arguments.length; v_indice++)
                            v_dataTable.row.add(arguments[v_indice]);
                    }
                };
                let v_funcionesSuplantadas;

                this.datos = function (p_datos) {
                    if (p_datos === v_arrayDatos) {
                        this.refresca();
                        return;
                    }
                    if (typeof v_arrayDatos !== 'undefined' && v_arrayDatos !== null && typeof v_funcionesSuplantadas !== 'undefined' && v_funcionesSuplantadas !== null) {
                        Object.getOwnPropertyNames(v_funcionesSuplantadas)
                            .forEach(p_nombre => v_arrayDatos[p_nombre] = v_funcionesSuplantadas[p_nombre]);
                        v_funcionesSuplantadas = void 0;
                    }
                    if (typeof p_datos !== 'undefined' && p_datos !== null) {
                        v_funcionesSuplantadas = {};
                        Object.getOwnPropertyNames(v_nuevasFunciones)
                            .forEach(p_nombre => {
                                v_funcionesSuplantadas[p_nombre] = p_datos[p_nombre];
                                p_datos[p_nombre] = v_nuevasFunciones[p_nombre];
                            });
                        //p_datos.push = function () {
                        //    Array.prototype.push.apply(this, arguments);
                        //    for (let v_indice = 0; v_indice < arguments.length; v_indice++)
                        //        p_dataTable.row.add(arguments[v_indice]);
                        //};
                    }

                    v_dataTable.clear();
                    if (Array.isArray(p_datos)) {
                        v_dataTable.rows.add(p_datos);
                    }
                    v_dataTable.draw();
                    v_arrayDatos = p_datos;

                    return this;
                };

                this.refresca = function () {
                    //v_dataTable.rows().invalidate('data').draw();
                    //v_dataTable.clear();
                    //if (Array.isArray(v_arrayDatos)) {
                    //    v_dataTable.rows.add(v_arrayDatos);
                    //}
                    //v_dataTable.draw(false);

                    v_dataTable.rows().invalidate().draw();
                    //v_dataTable.rows().every(p_indice => v_dataTable.rows(p_indice).invalidate());
                };

                this.filtro = function (p_filtro) {
                    if (typeof p_filtro !== 'undefined') {
                        v_dataTable.search(p_filtro).draw();
                    }
                };

                this.seleccionado = function () {
                    let v_objetos = Array.from(v_dataTable.rows({ selected: true }).data());
                    if (v_objetos.length <= 1)
                        return v_objetos[0];
                    else
                        return v_objetos;
                };

                this.busca = function (p_objeto) {
                    let v_filas = v_dataTable.rows()[0];

                    let v_objeto = Object.getOwnPropertyNames(p_objeto)
                        .reduce((p_anterior, p_propiedad) => {
                            let v_valor = p_objeto[p_propiedad];
                            if (typeof v_valor === 'string' && v_valor.length === 0) {
                                // nada
                            }
                            else
                                p_anterior[p_propiedad] = p_objeto[p_propiedad];
                            return p_anterior;
                        }, {});
                    let v_encontrados = v_filas
                        .filter(p_fila => Object.getOwnPropertyNames(v_objeto).every(p_propiedad => p_objeto[p_propiedad] === v_dataTable.row(p_fila).data()[p_propiedad]))
                        .map(p_indiceEncontrado => ({ Indice: p_indiceEncontrado, Fila: v_dataTable.row(p_indiceEncontrado).data() }));
                    return Array.from(v_encontrados);
                };

                this.selecciona = function (p_argumento, p_opciones) {
                    const v_alSeleccionar = p_valores.seleccionado;
                    p_valores.seleccionado = null;
                    try {
                        const
                            v_opciones = p_opciones || {},
                            v_notificar = v_opciones.notificar !== null && typeof v_opciones.notificar !== 'undefined' ? v_opciones.notificar : true;

                        v_dataTable.rows().deselect();
                        // quitamos la clase .selected a los nodos que pudieran quedar con dicha clase. 
                        // esto es así porque la navegación con los botones anterior y sigiuente de paginación
                        // establecen la clase .selected sin seleccionar realmente ninguna fila.
                        v_dataTable.row('.selected').nodes().to$().removeClass('selected');

                        let v_seleccionado;

                        if (arguments.length !== 0) {
                            if (Array.isArray(p_argumento)) {
                                let v_indices = p_argumento;
                                v_indices.forEach(p_indice => v_dataTable.rows(p_indice).select());
                                if (v_notificar && typeof v_alSeleccionar === 'function')
                                    v_seleccionado = this.seleccionado();
                            }
                            else if (p_argumento !== null) {
                                let v_indice = p_argumento;
                                v_dataTable.rows(v_indice).select();
                                if (v_notificar && typeof v_alSeleccionar === 'function')
                                    v_seleccionado = this.seleccionado();
                            }
                        }
                        if (v_notificar && typeof v_alSeleccionar === 'function')
                            v_alSeleccionar(v_seleccionado);
                    }
                    finally {
                        p_valores.seleccionado = v_alSeleccionar;
                    }
                };

                this.buscaYSelecciona = function (p_objeto, p_opciones) {
                    if (p_objeto) {
                        const
                            v_opciones = p_opciones || {},
                            v_seleccionaPrimero = v_opciones.seleccionaPrimero || false;
                        let v_encontrados = this.busca(p_objeto);
                        if (v_seleccionaPrimero) {
                            if (v_encontrados.length > 0) {
                                this.selecciona(v_encontrados[0].Indice, p_opciones);
                                return v_encontrados[0];
                            }
                            else {
                                this.selecciona(null, p_opciones);
                                return;
                            }
                        }
                        else {
                            this.selecciona(v_encontrados.map(p_encontrado => p_encontrado.Indice), p_opciones);
                            return v_encontrados;
                        }
                    }
                    else
                        this.selecciona(null, p_opciones);
                };

                this.editable = function (p_editable) {
                    if (arguments.length === 0)
                        return p_valores.editable;
                    else {
                        p_valores.editable = p_editable;
                        this.refresca();
                    }
                }




                //if (document.getElementById(p_selectorTabla.slice(1)) !== null)
                document.getElementById(p_selectorTabla).addEventListener('click', p_evento => {
                    const
                        v_elementoTd = p_evento.target.closest('td'),
                        v_columna = p_valores.columnas[v_elementoTd.cellIndex];

                    if (typeof v_columna.opcion !== 'string')
                        return;

                    const v_opcion = p_valores.opciones[v_columna.opcion];
                    if (typeof v_opcion.accion === 'function') {
                        const
                            v_elementoTr = v_elementoTd.closest('tr'),
                            v_fila = v_dataTable.row(v_elementoTr).data();
                        v_opcion.accion(v_fila);
                        p_evento.preventDefault();
                        p_evento.stopPropagation();
                    }
                    //v_dataTable
                    //    .row(v_fila)
                    //    .remove()
                    //    .draw();
                });

                //v_dataTable.on('user-select', function (p_evento, p_dataTable, p_tipo, p_celdas, p_eventoOriginal) {
                //    let v_seleccionado = typeof p_valores.seleccionado === 'function' ? p_valores.seleccionado : function (p_seleccion) { };

                //    // quitamos la clase .selected a los nodos que tuvieran dicha clase.
                //    // esto es así porque la navegación con los botones anterior y siguiente de paginación
                //    // establecen la clase .selected sin seleccionar realmente ninguna fila y por tanto,
                //    // cuando el evento concluya se seleccionará el registro indicado por el usuario y además quedarán marcados
                //    // como seleccionados visualmente aquellos que tuvieran anteriormente la clase .selected
                //    p_dataTable.row('.selected').nodes().to$().removeClass('selected');

                //    if (p_celdas.length === 0) {
                //        if (typeof p_valores.seleccionado === 'function') {
                //            v_seleccionado(null);
                //        }
                //    }

                //    let v_indice = p_celdas[0][0]; // Que cojones es esto???
                //    let v_definicionColumna = p_valores.columnas[v_indice.column];
                //    let v_celda = p_dataTable.cell(v_indice.row, v_indice.column);

                //    if (p_valores.editable && v_definicionColumna.editable) {
                //        if (typeof p_valores.seleccionado === 'function')
                //            v_seleccionado(null);
                //        configuraEditorCelda(v_celda.node(), v_celda);
                //        p_evento.preventDefault();
                //    }
                //    else if (typeof p_valores.seleccionado === 'function') {
                //        let v_seleccion = p_dataTable.row(v_indice.row).data();
                //        v_seleccionado(v_seleccion);
                //    }
                //}.bind(this));

                v_dataTable.on('select', function (p_evento, p_dataTable, p_tipo, p_indices) {
                    if (typeof p_valores.seleccionado === 'function') {
                        let v_objetos = this.seleccionado();
                        p_valores.seleccionado(v_objetos);
                    }
                }.bind(this));

                v_dataTable.on('deselect', function (p_evento, p_dataTable, p_tipo, p_indices) {
                    if (typeof p_valores.seleccionado === 'function')
                        p_valores.seleccionado(null);
                }.bind(this));


                v_dataTable.on('user-select', function (p_evento, p_dataTable, p_tipo, p_celdas, p_eventoOriginal) {
                    //let v_seleccionado = typeof p_valores.seleccionado === 'function' ? p_valores.seleccionado : function (p_seleccion) { };

                    // quitamos la clase .selected a los nodos que tuvieran dicha clase.
                    // esto es así porque la navegación con los botones anterior y siguiente de paginación
                    // establecen la clase .selected sin seleccionar realmente ninguna fila y por tanto,
                    // cuando el evento concluya se seleccionará el registro indicado por el usuario y además quedarán marcados
                    // como seleccionados visualmente aquellos que tuvieran anteriormente la clase .selected
                    //p_dataTable.row('.selected').nodes().to$().removeClass('selected');

                    //if (p_celdas.length === 0) {
                    //    if (typeof p_valores.seleccionado === 'function') {
                    //        v_seleccionado(null);
                    //    }
                    //}

                    let v_indice = p_celdas[0][0]; // Que cojones es esto???
                    let v_definicionColumna = p_valores.columnas[v_indice.column];

                    if (p_valores.editable && v_definicionColumna.editable) {
                        let v_celda = p_dataTable.cell(v_indice.row, v_indice.column);
                        //if (typeof p_valores.seleccionado === 'function')
                        //    v_seleccionado(null);
                        configuraEditorCelda(v_celda.node(), v_celda);
                        p_evento.preventDefault();
                    }
                    //else if (typeof p_valores.seleccionado === 'function') {
                    //    let v_seleccion = p_dataTable.row(v_indice.row).data();
                    //    v_seleccionado(v_seleccion);
                    //}
                }.bind(this));


                function configuraEditorCelda(p_td, p_celda) {
                    //debugger;
                    let v_indice = p_celda.index();
                    let v_definicionColumna = p_valores.columnas[v_indice.column];

                    let v_valorAnterior = p_celda.data();

                    function actualizaDatos(p_input) {
                        let v_valor;
                        switch (v_input.type) {
                            case 'number': v_valor = Number(p_input.value); break;
                            default: v_valor = p_input.value; break;
                        }
                        let v_fila = v_dataTable.row(v_indice.row).data();
                        let v_propiedad = v_definicionColumna.propiedad;
                        v_fila[v_propiedad] = v_valor;

                        if (typeof v_definicionColumna.cambio === 'function' && v_valor !== v_valorAnterior) {
                            v_definicionColumna.cambio(v_valor);
                            v_valorAnterior = v_valor;
                        }
                    }
                    let v_input = document.createElement('input');
                    v_input.style = "width:100%;height:100%;";

                    v_input.value = p_celda.data();
                    if (v_definicionColumna.numerico)
                        v_input.type = 'number';

                    v_input.classList.add('form-control', 'input-sm', 'input-xs');
                    v_input.classList.add('focusable');

                    if (v_definicionColumna.numerico)
                        v_input.classList.add('derecha');

                    const v_seleccionado = p_valores.seleccionado;
                    p_valores.seleccionado = void 0;

                    const v_manejador = {
                        handleEvent: function (p_evento) {
                            switch (p_evento.type) {
                                case 'blur': {
                                    p_evento.target.remove();
                                    actualizaDatos(p_evento.target);
                                    let v_valor = p_evento.target.value;
                                    p_td.innerText = v_valor;
                                    p_valores.seleccionado = v_seleccionado;
                                    break;
                                }
                                case 'keydown': {
                                    if (p_evento.key === 'Enter') {
                                        p_evento.target.blur();
                                        p_evento.stopPropagation();
                                    }
                                    break;
                                }
                            }
                        }
                    };

                    v_input.addEventListener('blur', v_manejador);
                    v_input.addEventListener('keydown', v_manejador);

                    p_td.firstChild.remove();
                    p_td.appendChild(v_input);
                    foco.en(v_input);
                    //v_input.select();
                    //v_input.focus();
                }

                //v_dataTable.on('click', 'td', function (p_evento) {
                //    let v_celda = v_dataTable.cell(p_evento.target);

                //    let v_indice = v_celda.index();
                //    if (typeof v_indice === 'undefined')
                //        return;

                //    let v_definicionColumna = p_valores.columnas[v_indice.column];

                //    if (/*p_evento.target.firstChild !== null &&*/ p_valores.editable && v_definicionColumna.editable) {
                //        configuraEditorCelda(p_evento.target, v_celda);
                //        p_evento.preventDefault();
                //    }
                //});

            }

            //let v_idElemento = '#' + (p_elemento instanceof HTMLElement ? p_elemento.id : p_elemento);
            let v_idElemento = p_elemento instanceof HTMLElement ? p_elemento.id : p_elemento;

            return new DefinicionTabla(v_idElemento, {
                datos: [],
                columnas: [],
                mensajeSinRegistros: null,
                editable: true
            });
        }

        function generateColumn(p_propiedad, p_titulo, p_visible, p_numerico, p_clase, p_opcion) {
            p_clase = p_clase || '';
            if (p_numerico) p_clase += ' dt-right';
            p_visible = typeof p_visible === 'undefined' || p_visible === null || p_visible ? true : false;
            var data = { 'name': p_titulo, 'title': p_titulo, "bVisible": p_visible };
            if (p_propiedad) {
                data.mDataProp = p_propiedad;
            }
            if (p_clase !== "") {
                data.sClass = p_clase;
            }
            if (p_opcion) {
                const v_boton = v_botones[p_opcion.boton];
                data.defaultContent = v_boton.contenido;
            }
            return data;
        }

        const v_botones = {
            elimina: { contenido: '<button class="opcion-elimina boton boton-delete">X</button>' }
        }

        tabla._creaColumnasDataTable = function (p_columnas, p_opciones) {
            let v_clasesAlineacion = {
                derecha: 'dt-right',
                centro: 'dt-center'
            };

            let v_columnasDataTable = p_columnas
                .map(function (p_columna) {
                    let v_propiedad = typeof p_columna.propiedad === 'string' ? p_columna.propiedad : null;
                    let v_opcion = p_columna.opcion;
                    let v_titulo = typeof p_columna.titulo === 'string' ? p_columna.titulo : p_columna.propiedad;
                    let v_visible = typeof p_columna.visible === 'boolean' ? p_columna.visible : true;
                    let v_numerico = typeof p_columna.numerico === 'boolean' ? p_columna.numerico : false;
                    let v_alineacion = typeof (p_columna.alineacion) === 'string' ? p_columna.alineacion : null;
                    let v_clase;
                    if (v_alineacion !== null && typeof v_clasesAlineacion[v_alineacion] === 'string') {
                        v_clase = v_clasesAlineacion[p_columna.alineacion];
                    }
                    return generateColumn(v_propiedad, v_titulo, v_visible, v_numerico, v_clase, p_opciones[v_opcion]);
                });
            return v_columnasDataTable;
        };

        tabla._creaDefinicionesDataTable = function (p_columnas) {
            let v_definicionesColumna = [];
            let v_definicionesOrden;

            p_columnas.forEach(function (p_columna, p_indice) {
                if ((typeof p_columna.ancho !== 'undefined' && p_columna.ancho !== null) ||
                    (typeof p_columna.orden !== 'undefined' && p_columna.orden !== null)) {

                    let v_definicionColumna = { targets: p_indice };

                    if (typeof p_columna.ancho !== 'undefined' && p_columna.ancho !== null) {
                        v_definicionColumna.width = p_columna.ancho;
                    }
                    if (typeof p_columna.orden !== 'undefined' && p_columna.orden !== null) {
                        v_definicionColumna.orderable = true;
                        let v_definicionOrden = [p_indice, p_columna.orden];
                        v_definicionesOrden = (v_definicionesOrden || []).concat([v_definicionOrden]);
                    } else {
                        v_definicionColumna.orderable = false;
                    }

                    v_definicionesColumna.push(v_definicionColumna);
                }
            });

            return {
                columnas: v_definicionesColumna,
                ordenaciones: v_definicionesOrden
            };
        };

        return tabla;
    });