﻿// @ts-nocheck
define('dialogo-detalle-bulto',
    [
    ],
    function (
    ) {
        class DialogoDetalleBulto {
            constructor(p_modal, p_bulto) {
                this.modal = p_modal;

                this.bulto = p_bulto; 

                this._tabla = p_modal.tabla('detalle')
                    .columnas([
                        { propiedad: 'GAART_COD', titulo: 'Código', ancho: 'auto' },
                        { propiedad: 'GAART_DESCRIP', titulo: 'Descripción', ancho: 'auto' },
                        { propiedad: 'CANTIDAD', titulo: 'Cantidad', ancho: '6em', numerico: true, },
                    ])
                    .crea();

                this._botonAceptar = p_modal.boton('aceptar')
                    .clic(this.acepta.bind(this))
                    .tecla('Enter')
                    .crea();
            }

            actualizaVista() {
                this._tabla.datos(this.bulto.articulos);
            }

            acepta() {
                this.modal.cierra();
            }
        }

        return DialogoDetalleBulto;
    });