declare class Api {
    private _url;
    private _metodo?;
    private _parametros?;
    private _ok?;
    private _error?;
    constructor(_url: string, _metodo?: 'get' | 'post' | 'put' | 'delete', _parametros?: any, _ok?: (p_resultado: any, p_mensaje: string) => void, _error?: (p_mensaje: string, p_resultado: any) => void);
    url(p_url: string): Api | ((p_url: string) => Api | any);
    metodo(p_metodo: 'get' | 'post' | 'put' | 'delete'): Api;
    metodo(): 'get' | 'post' | 'put' | 'delete';
    parametros(p_parametros: any): any;
    ok(p_funcion: (p_resultado: any, p_mensaje: string) => void): Api;
    error(p_funcion: (p_mensaje: string, p_resultado: any) => void): Api;
    invoca(): Promise<unknown>;
}
export declare function api(p_url: string): Api;
export {};
