export declare class DefinicionBoton {
    private _elemento;
    private _valores;
    constructor(_elemento: HTMLElement, _valores: {
        clic: (p_boton: Boton, p_evento: Event) => void;
        tecla: string;
    });
    clic(p_funcion: (p_boton: Boton, p_evento: Event) => void): DefinicionBoton;
    tecla(p_tecla: string): DefinicionBoton;
    crea(): Boton;
}
export declare class Boton {
    private _elemento;
    private _valores;
    constructor(_elemento: HTMLElement, _valores: {
        clic: (p_boton: Boton, p_evento: Event) => void;
        tecla: string;
    });
    etiqueta(p_valor: string): this;
    deshabilita(): this;
    habilita(): this;
    habilitado(p_valor?: boolean): boolean;
    visible(p_valor?: boolean): boolean;
}
export declare function boton(p_elemento: HTMLElement | string, p_valores?: {
    clic: (p_boton: Boton, p_evento: Event) => void;
    tecla: string;
}): DefinicionBoton;
