﻿var data;
var dataAux;
var datos = [];
var recepcion;
var detallesProd = [];
var v_orden_recepcion = [];
var v_lineas;
var v_lineas_pedido = [];
var v_cant_linea;
var v_pedidoActual_cant;
var v_pedidoActual_cant_aux = 0;
var v_control_lote_ubic;
var v_posicion_pedido;
var n_albaranes;

function initialize() {
    data;
    dataAux;
    datos = [];
    recepcion;
    detallesProd = [];
    v_orden_recepcion = [];
    v_lineas;
    v_lineas_pedido = [];
    v_cant_linea;
    v_pedidoActual_cant;
    v_pedidoActual_cant_aux = 0;
    v_control_lote_ubic;
    v_posicion_pedido;
    n_albaranes;
    $('#txtPedido').get(0).focus();
}

$(document).ready(function () {
    initialize();

    var btnNuevo = document.getElementById('btnNuevoPedido');
    addEvent(btnNuevo, 'click', clear, false);
    function clear() {
        initialize();
        v_tabla.clear().draw();
        $(txtPedido).val("").focus().select();
    }

    v_columns = [generateColumn("N_LIN", "ID", false), generateColumn("GAART_UBIC_SN", "ID", false), generateColumn("GAART_LOTES_SN", "ID", false), generateColumn("GAART_COD", Resources.table_head_article), generateColumn("GAART_DESCRIP", Resources.table_head_description), generateColumn("C_PDTE", Resources.table_head_pending, true, true)];

    var columnDefs = [
        { width: '6em', targets: 3 },
        { width: '4em', targets: 5 }
    ];

    createTableJson('#tablaPedidos', null, v_columns, null, null, columnDefs);

    var tBody = $('#tablaPedidos tbody');

    var v_tabla = $('#tablaPedidos').DataTable();

    v_lineas = v_tabla.rows().data();

    function recepcionRowData(e) {
        var selectedRow = v_tabla.row(e.target)[0];
        $('#descArticulo').val(v_tabla.rows(selectedRow).data()[0].GAART_DESCRIP);
        $('#ref #campRefer').val(v_tabla.rows(selectedRow).data()[0].GAART_COD);

        var lotes = v_tabla.rows(selectedRow).data()[0].GAART_LOTES_SN;
        var ubicaciones = v_tabla.rows(selectedRow).data()[0].GAART_UBIC_SN;

        var LotUbic = $('#tablaPedidos').DataTable().row(selectedRow).data().GAART_LOTES_SN + $('#tablaPedidos').DataTable().row(selectedRow).data().GAART_UBIC_SN;
        var N_lin = $('#tablaPedidos').DataTable().row(selectedRow).data().N_LIN;
        $($('#tablaPedidos').DataTable().row(selectedRow).node()).addClass(LotUbic).prop("id", N_lin);
        row = $(v_tabla.row(selectedRow).node());
        controlLotUb(row);
    }


    // RBM 03/03/20 Cambio la validación con la pulsación del Intro para hacerla con el evento 'change'
    //$('#txtPedido').keypress(function (e) {
    //    if (e.which === 13) {
    $('#txtPedido').on("change", function (e) {
        {
            $('#txtPedido').val($('#txtPedido').val().toUpperCase());
            var v_url = "recepcion/pedido";
            var v_method = "GET";
            var v_data = { empgrupo_cod: sessionStorage.getItem("EMPRGRUP_COD"), emp_cod: sessionStorage.getItem("EMPR_COD"), lecturaPedido: $('#txtPedido').val() };
            var v_success = function (response) {
                if (response.Ok) {
                    dataAux = response.Objeto;
                    n_albaranes = dataAux.Albaranes.length;
                    if (dataAux.OBSER && dataAux.OBSER.trim() !== "") {
                        lanzarMensaje(response.Ok, dataAux.OBSER, observFunc);
                    } else {
                        lanzarAlbaranes();
                    }
                } else {
                    lanzarMensaje(response.Ok, response.Mensaje, function () { $('#txtPedido').focus().select(); });
                }
            };
            apiGeneral(v_url, v_method, v_data, v_success);
            $(this).blur();
            e.preventDefault();
        }
    });

    $('#tablaPedidos').on('click', 'tbody', function (e) {
        if (v_lineas.length > 0) {
            recepcionRowData(e);
            if (!dialogOpening) {
                var tableRow = $(v_tabla.row(e.target).node());

                //Si no tiene control de lotes ni ubicaciones seguira por la función
                controlLotUb(tableRow);

                if (!tableRow.hasClass('NN')) {
                    dialogOpening = true;
                    v_posicion_pedido = eval(v_tabla.row(tableRow).data().N_LIN);
                    for (i = 0; i < v_lineas.length; i++) {
                        if (v_lineas_pedido.length < v_lineas.length) {
                            v_lineas_pedido.push({ 'C_UNI1': 0, 'N_LIN': v_lineas[i].N_LIN });
                        }
                    }
                    v_lineas = v_tabla.rows().data();
                    v_pedidoActual_cant = 0;
                    detallesProd = [];
                    v_cant_linea = v_tabla.rows(tableRow).data()[0].C_PDTE;
                    v_control_lote_ubic = 'SS';
                    var v_dialog = "#dialogPedidos";
                    var v_nombre_tabla = 'tablaUbicaciones';

                    var v_column = [
                        { "mDataProp": "GAUBIC_COD", name: Resources.table_head_location },
                        { "mDataProp": "LOTE", name: Resources.table_head_batch },
                        { "mDataProp": "C_UNI1", name: Resources.table_head_available }
                    ];
                    var columnDefs = [
                        { width: '6em', targets: 0 },
                        { width: '4em', targets: 2 }
                    ];
                    var id = buscarLineaPedido(tableRow.prop('id'));

                    if (!tableRow.hasClass('SS')) {
                        var col = tableRow.hasClass('NS') ? true : false;
                        if (col) {
                            v_control_lote_ubic = 'NS';
                            v_column = [{ "mDataProp": "GAUBIC_COD", name: Resources.table_head_location }, { "mDataProp": "LOTE", name: Resources.table_head_batch, "sClass": "dt_col_hide" }, { "mDataProp": "C_UNI1", name: Resources.table_head_available }];
                            columnDefs = [
                                { "width": "4em", "targets": 2 }
                            ];
                        } else {
                            v_control_lote_ubic = 'SN';
                            v_column = [{ "mDataProp": "GAUBIC_COD", name: Resources.table_head_location, "sClass": "dt_col_hide" }, { "mDataProp": "LOTE", name: Resources.table_head_batch }, { "mDataProp": "C_UNI1", name: Resources.table_head_available }];
                            columnDefs = [
                                { "width": "4em", "targets": 2 }
                            ];
                        }
                    }
                    var pedido = $('#txtPedidoHidden').val();
                    //var url = Router.action('Dialog', 'Dialog');
                    var url = "Dialog/Dialog";

                    var inputs =
                        [
                            generateSingleInput(4, Resources.label_ubicacion, 'txtUbic', '', 'campUbicacion'),
                            generateSingleInput(5, Resources.label_lote, 'txtLote', '', 'campLote'),
                            generateSingleInput(3, Resources.label_quantity, 'txtCant', '', 'campCant', 'text-right', true)
                        ];
                    var upperInputs =
                        [
                            generateSingleInput(6, Resources.label_ref, 'txtRef', v_tabla.rows(tableRow).data()[0].GAART_COD, 'campRef'),
                            generateSingleInput(6, Resources.label_pending, 'txtPdte', '', 'campPdte', 'text-right', true)
                        ];
                    var buttons = [{ id: 'aceptar', value: Resources.button_accept }];
                    var pos = 0;
                    for (i = 0; i < v_lineas_pedido.length; i++) {
                        if (v_lineas_pedido[i].N_LIN === v_posicion_pedido) {
                            pos = i;
                        }
                    }
                    v_dataClon = JSON.parse(JSON.stringify(data));

                    //generarDialogAuto(url, v_dialog, v_nombre_tabla, null, v_tabla.rows('.selected').data()[0].Existencias, v_column, buttons, inputs, upperInputs, selectUbicacion, Resources.title_location, null, null, null, null, null, null, columnDefs);
                    generarDialogAuto(url, v_dialog, v_nombre_tabla, null, v_dataClon.Lineas[id].Existencias, v_column, buttons, inputs, upperInputs, selectUbicacion, Resources.title_location, null, null, null, null, null, null, columnDefs);

                }
            }
        } else {
            $('#confirmar').prop('disabled', true);
        }
    });

    // RBM 03/03/20 Cambio la validación con la pulsación del Intro para hacerla con el evento 'change'
    //$('#campRefer').keypress(function (e) {
    //    if (e.which === 13) {
    $('#campRefer').on("change", function (e) {
        {
            //$(this).blur();
            if ($('#tablaPedidos').DataTable().rows().data().length === 0) {
                lanzarMensaje(false, Resources.error_select_order, function () { $('#txtPedido').focus().select(); });
            } else if (!buscarProducto()) {
                lanzarMensaje(false, "Artículo no encontrado", function () { $('#campRefer').focus().select(); });
                $('.sinLote').hide();

            } else {
                $('#tablaPedidos .selected').click();
            }
            //e.preventDefault();
        }
    });

    $('#ref #campCant').on('change', cantSinLotUb);

    $('#confirmar').on('click', function () {
        if (v_pedidoActual_cant_aux && v_pedidoActual_cant_aux > 0) {
            generarRecepcion();
            showDialog('#dialogRefAlbaran');
            $('#codRefAlbaran').focus().select();
            aceptar();
        } else {
            lanzarMensaje(false, Resources.error_prep_pedido);
        }
    });

    $('#campRefer').on('click', function () {
        v_code = "";
    });
});

$(window).resize(function () {
    cambioTamanioPed();
});

function aceptar() {
    $('#envioAceptar').on('click', function () {

        v_orden_recepcion.SU_REF_ALB = $('#codRefAlbaran').val();
        expedirRecepcion();
        closeModal('#dialogLoV');
    });
}

function observFunc() {

    lanzarAlbaranes();

}

function lanzarAlbaranes() {
    //var url = Router.action('Dialog', 'Dialog');
    var url = "Dialog/Dialog";

    var v_columns = [
        generateColumn('GGALBTIP_COD', Resources.table_head_type),
        generateColumn('N_ALBARAN', Resources.table_head_number, true, true),
        generateColumn('F_ALBARAN', Resources.table_head_date),
        generateColumn('GGESTADO_COD', Resources.table_head_state),
        generateColumn('F_ALBARAN_HID', '', false)
    ];

    var columnDefs = [
        { "width": "4em", "targets": 0 },
        { "width": "4em", "targets": 1 },
        { "className": "dt-center", "targets": 2 },
        { "width": "2em", "targets": 3 }
    ];
    var buttons = [generateSingleButton('seleccionarAlbaran', Resources.button_select, 'pull-right'), generateSingleButton('nuevoAlbaran', Resources.button_new, 'pull-left', 'gray')];
    if (dataAux.Albaranes.length !== 0) {
        var v_albaranes = dataAux.Albaranes.map(function (albaran) {
            return {
                GGALBTIP_COD: albaran.GGALBTIP_COD,
                N_ALBARAN: albaran.N_ALBARAN,
                //Fecha formateada para su visualización
                F_ALBARAN: moment(albaran.F_ALBARAN).format(Globalize($("html").attr("lang")).culture().calendar.patterns.d.toUpperCase()),
                GGESTADO_COD: albaran.GGESTADO_COD,
                SU_REF_ALB: albaran.SU_REF_ALB,
                //Fecha sin formatear (Oculto)
                F_ALBARAN_HID: albaran.F_ALBARAN
            };
        });
        generarDialogAuto(url, "#dialogLoV", 'tablaAlbaranes', null, v_albaranes, v_columns, buttons, null, null, selectAlbaranPintarPed, Resources.title_delivery_note_selection, null, null, null, null, null, null, columnDefs);
    } else {
        datosAlbaran("", "", "");
        pintarTablaPedidos();
    }
}

function envioConfirmar() {
    expedir();
    $('#dialogEnviosEtiquetas #codTransportistaInput').prop("value", $('#codTransporte').val());
    $('#dialogEnviosEtiquetas #nombreTransportistaInput').prop("value", $('#nombreTransporte').val());
    $('#dialogEnviosEtiquetas #codVehiculoInput').prop("value", $('#codVehiculo').val());
    $('#dialogEnviosEtiquetas #descrVehiculoInput').prop("value", $('#descrVehiculo').val());
    $('.transp').addClass('half');
}

function buscarLineaPedido(id) {
    for (i = 0; i < data.Lineas.length; i++) {
        if (data.Lineas[i].N_LIN === eval(id)) {
            return i;
        }
    }
}
var dialogOpening = false;
function cantSinLotUb() {
    var v_tabla = $('#tablaPedidos').DataTable();
    v_posicion_pedido = eval($('#tablaPedidos').DataTable().row('.selected').data().N_LIN);
    var v_cantVal = $('#ref #campCant').val().trim();
    if ($.isNumeric(v_cantVal) && v_cantVal !== 0) {
        for (i = 0; i < v_lineas.length; i++) {
            if (!v_lineas_pedido[i]) {
                v_lineas_pedido.push({ 'C_UNI1': 0, 'N_LIN': eval(v_lineas[i].N_LIN) });
            }
        }
        detallesProd = [];
        var posicion = buscarLineaPedido($('#tablaPedidos').DataTable().rows('.selected').data()[0].N_LIN);
        var v_cantidad = eval($('#ref #campCant').val());
        v_pedidoActual_cant = 0;
        modCantidades(v_cantidad, eval(v_tabla.rows('.selected').data()[0].C_PDTE), null, "", "");
        recogerDetalles();
        v_pedidoActual_cant_aux += v_pedidoActual_cant;
        $('#ref #campCant').val("");
    }
}

function controlLotUb(JQInput) {
    if (JQInput.hasClass('NN')) {
        $('#txtRefer').removeClass('col-xs-10');
        $('#txtRefer').addClass('col-xs-5');
        $('.sinLote').show();
        $('#ref #campCant').focus();
        if (typeof v_code !== 'undefined' && v_code !== "" && v_code.obtenerIdentificadores.length > 0) {
            for (i = 0; i < v_code.obtenerIdentificadores.length; i++) {
                if (v_code.obtenerIdentificadores[i].ia === "37") {
                    $('#ref #campCant').val(v_code.obtenerIdentificadores[i].valor);
                }
            }
        }
    } else {
        $('#txtRefer').addClass('col-xs-10');
        $('#txtRefer').removeClass('col-xs-5');
        $('.sinLote').hide();
    }
}

function buscarProducto() {
    return seleccionFila("#tablaPedidos", [{
        KEY: "GAART_COD",
        VALUE: $('#campRefer').val()
    }]);
}
function buscarMultProductos(cod_producto) {
    for (j = 0; j < $('#tablaPedidos').DataTable().rows().data().length; j++) {
        if ($('#tablaPedidos').DataTable().rows().data()[j].GAART_COD === cod_producto) {
            var GAART_COD = $('#tablaPedidos').DataTable().rows().data()[j].GAART_COD;
            var GAART_DESCRIP = $('#tablaPedidos').DataTable().rows().data()[j].GAART_DESCRIP;
            return { GAART_COD: GAART_COD, GAART_DESCRIP: GAART_DESCRIP };
        }
    }
    return null;
}

function seleccionProdRepetido() {
    $('#dialogLoV #accept').on('click', function () {
        $('#campRefer').val($('#LoVTable').DataTable().row('.selected').data()[0]);
        closeModal('#dialogLoV');
        $('#campRefer').trigger(jQuery.Event('keypress', { which: 13 }));
    });
}

function productosMultiples(v_articulos) {
    //En caso de que haya más de un producto con el mismo código en el pedido
    if (v_articulos.length > 1) {
        //var url = Router.action('Dialog', 'Dialog');
        var url = "Dialog/Dialog";

        var v_columns = [generateColumn('GAART_COD', Resources.table_head_code), generateColumn('GAART_DESCRIP', Resources.table_head_description)];
        var columnDefs = [
            { width: '6em', target: 0 }
        ];
        var v_buttons = [generateSingleButton('accept', Resources.button_accept)];
        generarDialogAuto(url, '#dialogLoV', 'LoVTable', null, v_articulos, v_columns, v_buttons, null, null, seleccionProdRepetido, Resources.title_multiple_products, null, Resources.message_multiple_products, null, null, null, null, columnDefs);
    }
    return v_articulos;
}

//function menuElement(name, icon, href, value, valueIcon, id) {
//    var menuHtml = '<li id="' + id + '" class="col-xs-12 pull-left"> \
//                            <a href="' + href + '"><i class="glyphicon glyphicon-' + icon + '"></i>&nbsp;&nbsp;' + name;
//    if (value !== '') {
//        menuHtml = menuHtml + '<div class="pull-right text-right"><input class="invisible-input" readonly value="' + value + '">&nbsp;<i class="glyphicon glyphicon-' + valueIcon + '"> </i></div>';
//    }
//    menuHtml = menuHtml + '</a></li>';

//    $('#nav-user').append(menuHtml);
//}


function recogerDetalles() {
    for (i = 0; i < v_lineas_pedido.length; i++) {
        if (!v_lineas_pedido[i]["Detalles"]) {
            v_lineas_pedido[i]["Detalles"] = new Array();
        }
        for (j = 0; j < detallesProd.length; j++) {
            if (v_lineas_pedido[i].N_LIN === eval(detallesProd[j].N_LIN)) {
                if (!repetido(i) && (detallesProd[j].GAUBIC_COD || detallesProd[j].LOTE)) {
                    v_lineas_pedido[i]["Detalles"].push(detallesProd[j]);

                }

                if (!v_lineas[i].C_PDTE) {
                    v_lineas[i].C_PDTE = eval(detallesProd[j].C_UNI1);
                } else {
                    v_lineas_pedido[i].C_UNI1 = v_lineas_pedido[i].C_UNI1 + eval(detallesProd[j].C_UNI1);
                }
            }
        }
    }
    var pos_v_lineas;
    var encontrado = false;
    data = JSON.parse(JSON.stringify(v_dataClon));

    for (i = 0; i < v_lineas.length && !encontrado; i++) {
        if (data.Lineas[i].N_LIN === $('#tablaPedidos').DataTable().rows('.selected').data()[0].N_LIN) {
            pos_v_lineas = i;
            encontrado = true;
        }
    }
    var v_table = $('#tablaPedidos').DataTable();
    v_table.row('#' + v_posicion_pedido).data(data.Lineas[pos_v_lineas]).draw();

    cambioColorPedido(v_lineas_pedido);
    $("#campRefer").focus().select();
}

function repetido(i) {
    for (k = 0; k < v_lineas_pedido[i]["Detalles"].length; k++) {
        if (detallesProd[j]['LOTE'] === v_lineas_pedido[i]["Detalles"][k]['LOTE'] && detallesProd[j]['GAUBIC_COD'] === v_lineas_pedido[i]["Detalles"][k]['GAUBIC_COD']) {
            v_lineas_pedido[i].Detalles[k].C_UNI1 += detallesProd[j].C_UNI1;
            if (v_lineas_pedido[i].Detalles[k].C_UNI1 === 0) {
                v_lineas_pedido[i].Detalles.splice(k, 1);
            }
            return true;
        }
    }
    return false;
}

function cambioColorPedido(v_lineas_pedido) {
    var v_table = $('#tablaPedidos').DataTable();
    var row = v_table.row('#' + v_posicion_pedido).node();

    for (i = 0; i < v_lineas_pedido.length; i++) {
        if (v_lineas_pedido[i].N_LIN === v_posicion_pedido && v_lineas_pedido[i].C_UNI1 !== 0) {
            if (!$(row).hasClass('green')) {
                $(row).addClass('green');
            }
            return;
        }
    }
}

function generarRecepcion() {
    v_orden_recepcion = {
        EMPGRUPO_COD: sessionStorage.getItem("EMPRGRUP_COD"),
        EMP_COD: sessionStorage.getItem("EMPR_COD"),
        GGPEDTIP_COD: $("#txtPedido").val().split('-')[0],
        N_PEDIDO: $("#txtPedido").val().split('-')[1],
        GGALBTIP_COD: $("#tipoAlbaran").val(),
        N_ALBARAN: $("#numAlbaran").val(),
        F_ALBARAN: getFechaAlbaran(),
        LINEAS: v_lineas_pedido
    };
}

function expedirRecepcion() {
    var url = "recepcion/recepcionar";
    var method = "POST";
    var data = v_orden_recepcion;
    var success = function (response) {
        //var url = Router.action('Recepcion', 'Index');
        var url = "Recepcion/Index";
        lanzarMensajeRedirect(response.Ok, response.Mensaje, url);
    };

    apiGeneral(url, method, data, success);

}