﻿function selectUbicacion() {
    dialogOpening = false;
    var v_table = $('#tablaUbicaciones').DataTable();
    var txtCant = $('#txtCant');
    var txtLote = $('#txtLote');
    var txtUbic = $('#txtUbic');
    var btnAccept = document.getElementById('aceptar');

    if (v_control_lote_ubic === 'SN') {
        $('#campUbicacion').hide();
        $('#campLote').removeClass('col-xs-5');
        $('#campLote').addClass('col-xs-7');
        $('#campCant').removeClass('col-xs-3');
        $('#campCant').addClass('col-xs-5');
    } else if (v_control_lote_ubic === 'NS') {
        $('#campLote').hide();
        $('#campUbicacion').removeClass('col-xs-4');
        $('#campUbicacion').addClass('col-xs-7');
        $('#campCant').removeClass('col-xs-3');
        $('#campCant').addClass('col-xs-5');
    }
    $('#tablaUbicaciones tbody').on('mousedown', ubicationData);

    addEvent(btnAccept, 'click', confirmarUbicaciones, false);
    // RBM 03/03/20 Cambio la validación con la pulsación del Intro para hacerla con el evento 'change'
    //txtUbic.keyup(function (e) {
    //    if (e.which === 13) {
    txtUbic.on("change", function (e) {
        {
            if ($(this).val() !== "") {
                getUbic();
                setTimeout(function () {
                    focusCant();
                    focusLote();
                });
                e.preventDefault();
            }
        };
    });

    // RBM 03/03/20 Cambio la validación con la pulsación del Intro para hacerla con el evento 'change'
    //txtLote.keyup(function (e) {
    //    if (e.which === 13) {
    txtLote.on("change", function (e) {
        {
            if ($(this).val() !== "") {
                getLote();
                focusCant();
                e.preventDefault();
            }
        }
    });
    function ubicationData() {
        var selectedRow = v_table.row('.selected')[0];
        $('#txtUbic').val(v_table.rows(selectedRow).data()[0].GAUBIC_COD);
        $('#txtLote').val(v_table.rows(selectedRow).data()[0].LOTE);
    }



    function getUbic() {
        if ($('#txtUbic').val().trim() !== "")
            var arrayBusqueda = [];
        arrayBusqueda.push({ KEY: 'GAUBIC_COD', VALUE: $('#txtUbic').val() });
        var existeFila = seleccionFila("#tablaUbicaciones", arrayBusqueda);
        if (v_control_lote_ubic === 'NS') {
            if (existeFila) $('#tablaUbicaciones .selected').click();
        } else {
            setUbicLote();
        }
    }

    function getLote() {
        if (txtLote.val().trim() !== "")
            var arrayBusqueda = [];
        if (v_control_lote_ubic === 'SN') {
            arrayBusqueda.push({ KEY: 'LOTE', VALUE: txtLote.val() });
        } else {
            arrayBusqueda.push({ KEY: 'GAUBIC_COD', VALUE: $('#txtUbic').val() }, { KEY: 'LOTE', VALUE: txtLote.val() });
        }
        var existeFila = seleccionFila("#tablaUbicaciones", arrayBusqueda);
        if (existeFila) $('#tablaUbicaciones .selected').click();
    }
    // RBM 03/03/20 Cambio la validación con la pulsación del Intro para hacerla con el evento 'change'
    //txtCant.keypress(function (e) {
    //    if (e.which === 13) {
    txtCant.on("change", function (e) {
        {
            if ($(this).val()) ubicacion();
        }
    });

    $('#tablaUbicaciones').on("click", "tr", function () {
        if (v_table.rows().count() > 0) {
            setUbicLote();

            var pendiente = $('#txtPdte').val();

            txtCant.val(setOptimumQty(pendiente, pendiente)).focus();
        }
    });

    $('#dialogPedidos').on('shown.bs.modal', function () {
        code();
        if (v_control_lote_ubic === 'SN') {
            $('#txtLote').focus();
        } else {
            $('#txtUbic').focus();
        }
    });

    $('#dialogMessage').on('hidden.bs.modal', function () {
        $('#aceptar').prop('disabled', false);
    });

    $('#dialogLoV .close').on("click", function () {
        restartData();
    });

    function setUbicLote() {
        if (v_table.rows().count() !== 0) {
            $('#txtUbic').val(v_table.row('.selected').data().GAUBIC_COD);
            $('#txtLote').val(v_table.row('.selected').data().LOTE);
        }
    }

    function focusUbic() {
        txtUbic.focus().select();
    }

    function focusLote() {
        txtLote.focus().select();
    }

    function focusCant() {
        txtCant.focus().select();
    }
    $("#txtPdte").val(v_cant_linea);

    function confirmarUbicaciones() {
        // RBM 03/03/20 Cambio la validación con la pulsación del Intro para hacerla con el evento 'change'
        //var e = jQuery.Event("keypress");
        //e.which = e.keyCode = 13;
        var e = jQuery.Event("change");
        $(txtCant).trigger(e);

        recogerDetalles();
        v_pedidoActual_cant_aux += v_pedidoActual_cant;
        $("#dialogPedidos").modal('hide');
    }
}

function resetFocus() {
    if (v_control_lote_ubic === 'SN') {
        $('#txtLote').focus().select();
    } else {
        $('#txtUbic').focus().select();
    }
}

function ubicacion() {
    var v_ubicacion = $('#txtUbic').val();
    v_ubicacion = v_ubicacion.trim() === "" ? "*" : v_ubicacion;
    var v_lote = $('#txtLote').val();
    v_lote = v_lote.trim() === "" ? "*" : v_lote;

    $('#txtUbic').val(v_ubicacion);
    var v_pdte = eval($('#txtPdte').val());
    var v_cantidad = $('#txtCant').val();
    if (v_cantidad !== "" && v_cantidad !== 0) {
        if ($.isNumeric(v_cantidad)) {
            v_cantidad = eval(v_cantidad);
            var v_table = $("#tablaUbicaciones").DataTable();
            var selectedData = v_table.rows('.selected').data()[0];

            modCantidades(v_cantidad, v_pdte, v_table, v_ubicacion, v_lote, selectedData);
            setTimeout(function () {
                $('#txtCant').val('');
                $('#txtLote').val('').focus();
                $('#txtUbic').val('').focus();
            }, 0);
        } else {
            $('#txtCant').val("");
        }
    }
}


function modCantidades(cantidad, pdte, table, ubic, lote, selectedData) {
    pdte = pdte - cantidad;
    for (i = 0; i < v_dataClon.Lineas.length; i++) {
        if (v_dataClon.Lineas[i].N_LIN === v_posicion_pedido) {
            v_dataClon.Lineas[i].C_PDTE = pdte;
        }
    }
    $('#txtPdte').val(pdte);
    $('#txtCant').val("");
    var v_anadido = { GAUBIC_COD: ubic, LOTE: lote, C_UNI1: cantidad, C_UNI2: 0 };
    var v_anadidoDetalles = { N_LIN: v_posicion_pedido, GAUBIC_COD: ubic, LOTE: lote, C_UNI1: cantidad };
    if (!selectedData && table) {
        detallesProd.push(v_anadidoDetalles);
        $('#tablaPedidos').DataTable().rows('.selected').data()[0].Existencias.push(v_anadido);
        table.row.add(v_anadido).draw();
    } else if (table) {
        selectedData.C_UNI1 = selectedData.C_UNI1 + cantidad;
        var encontrado = false;
        var i = 0;

        detallesProd.map(function (detalle) {
            if (detalle.GAUBIC_COD === selectedData.GAUBIC_COD && detalle.LOTE === selectedData.LOTE) {
                detalle.C_UNI1 += cantidad;
                if (detalle.C_UNI1 === 0) {
                    detallesProd.splice(i, 1);
                }
                encontrado = true;
            }
            i++;
        });
        if (!encontrado) {
            detallesProd.push(v_anadidoDetalles);
        }
        table.rows().invalidate().draw();
        //table.cell('.selected').data(v_cant);
    } else {
        detallesProd.push(v_anadidoDetalles);
    }

    v_pedidoActual_cant += cantidad;
}


function code() {
    if (typeof v_code !== 'undefined' && v_code !== "" && v_code.obtenerIdentificadores.length > 0) {
        for (i = 0; i < v_code.obtenerIdentificadores.length; i++) {
            if (v_code.obtenerIdentificadores[i].ia === "10") {
                $('#txtLote').val(v_code.obtenerIdentificadores[i].valor);
                $('#txtLote').trigger(jQuery.Event('keypress', { which: 13 }));
            }
            if (v_code.obtenerIdentificadores[i].ia === "37") {
                $('#txtCant').val(v_code.obtenerIdentificadores[i].valor);
            }
        }
        $('#detallesUbicacion .selected').click();
        v_code = "";
    }
}