﻿define('label',
    [],
    function () {
        function label(p_elemento) {
            function DefinicionLabel(p_elemento, p_valores) {

                this.texto = this.valor = function (p_valor) {
                    return new DefinicionLabel(p_elemento, Object.assign(p_valores, { texto: p_valor }));
                };

                this.crea = function () {
                    return new Label(p_elemento, p_valores);
                };
            }

            function Label(p_elemento, p_valores) {

                this.texto = this.valor = function (p_valor) {
                    if (arguments.length === 1) {
                        p_elemento.textContent = p_valor;
                    } else {
                        return p_elemento.textContent;
                    }
                };

                this.visible = function (p_valor) {
                    if (arguments.length === 0)
                        return !p_elemento.classList.contains('oculto');
                    else {
                        if (p_valor)
                            p_elemento.classList.remove('oculto');
                        else
                            p_elemento.classList.add('oculto');
                    }
                };

                this.texto(p_valores.texto);
            }

            var v_elemento = p_elemento instanceof HTMLElement ? p_elemento : document.getElementById(p_elemento)
            return new DefinicionLabel(v_elemento, {
                texto: v_elemento.innerHTML
            });
        }

        return label;
    });