﻿define('mensaje',
    [
        'pregunta'
    ],
    function (
        pregunta
    ) {

        function mensaje(p_texto) {
            if (arguments.length === 0) {
                p_texto = '';
            }

            function Mensaje(p_texto, p_error) {
                let v_texto = p_texto;
                let v_error = p_error;

                this.texto = function (p_texto) {
                    if (typeof p_texto !== 'string') {
                        throw new Error('No es un texto válido');
                    }
                    return new Mensaje(p_texto, v_error);
                };

                this.error = function () {
                    return new Mensaje(v_texto, true);
                };

                this.muestra = async function (p_texto) {
                    if (typeof p_texto === 'string') {
                        v_texto = p_texto;
                    }

                    let v_pregunta = pregunta(v_texto)
                        .opciones(['Aceptar'])
                        .opcionPredeterminada('Aceptar');

                    if (v_error)
                        v_pregunta = v_pregunta.error();

                    return await v_pregunta.muestra();
                };
            }

            return new Mensaje(p_texto, false);
        }

        return mensaje;
    });